clear

nx = 76
ny = 100

dx = 3;
dy = 10;

h0 = 6;
hmin = 0.05;

xcen = 51;
ycen = ny/2;
mamp = 1.35;


xx =  (((0:nx-1)')*ones(1,ny)*dx)';

xx(ny+1:2*ny,1:nx) = (ones(nx,1)*(0:ny-1)*dy)';


for j = 1:nx
   for i = 1:ny
      h(j,i) = h0 - (j-1)/nx*h0  ...
         - mamp*sech( (j-xcen)^2*0.02 )^2;
     
%     h(j,i) = h0 - (j-1)/nx*h0  ...
%     - mamp*sech( (j-xcen)^2*0.02 + (i-ycen)^2*0.0015 )^2;

end
end


h = max(h,hmin)';


plot(-h')


save -ascii xymast.dat xx

save -ascii depth.dat h