clear

for j = 1: 100000000

load junk2.out
load junk4.out
load junk3.out

u = junk2;
v = junk4;
amp = junk3;


figure(1)
clf
subplot(4,1,1)
plot(junk2)
subplot(4,1,2)
plot(junk4)
subplot(4,1,3)
plot(junk3)

dx = 3;
dy = 10;

[ nx ny] = size(junk2);


vx = zeros(size(v));
vx(2:nx-1,:) = (v(3:nx,:)-v(1:nx-2,:))/(2*dx);

uy = zeros(size(u));
uy(:,2:ny-1) = (u(:,3:ny)-u(:,1:ny-2))/(2*dy);
uy(:,1) = (u(:,2)-u(:,ny))/(2*dy);
uy(:,ny) = (u(:,1)-u(:,ny-1))/(2*dy);

vort = vx-uy;


figure(2)
clf
pcolor(vort), shading interp

%nxskip = 4; nyskip = 2;
%quiver(junk5(1:nxskip:nx,1:nyskip:ny),junk2(1:nxskip:nx,1:nyskip:ny))

pause(100)

end