
        program fgen

        include 'params.h'

        real hgen, dum1, wn, fundl
        real external rand1

        integer i,j,k, jran
        integer  ia, ic, im
        
c        ia = 9301
c        im = 233280
c        ic = 49297
c        jran = 32432

c Read in spectral quantities and generation depth

        open(1,file='spec.dat')
	  read(1,*) ia, im, ic, jran
        read(1,*)nfreqs
        read(1,*) hgen
        do k = 1, nfreqs
         read(1,*) sfreq(k), famp(k), sang(k)
         sang(k) = sang(k)*pi/180.
        end do
        close(1)

c find length of periodivc domain and calculate fundamental
c l-wavenumber
c        open(1,file='winput.dat')
c         read(1,*) dum1          
c         read(1,*) cny0
c         read(1,*) dum1
c         read(1,*) dum1
c         read(1,*) cdy
c        close(1)
c        fundl = 2.*pi/(cdy*cny0)

c compute random phase and integer wavenumber cycle
        do k = 1, nfreqs
         call wnum(sfreq(k), hgen, wn)
         wll(k) = wn*sin(sang(k))
c         wcyc(k) = int(wll(k)/fundl + 0.5) 
         jran = mod(jran*ia + ic, im)
         phase(k) = float(jran)/float(im) *2.*pi 
         print *, wn, wll(k), phase(k)
        end do

c     output final quantities
      
        open(1,file='freqs.dat')
        write(1,*) nfreqs
        do k = 1, nfreqs
         write(1,*) sfreq(k)*2.*pi, famp(k), phase(k), wll(k)
        end do
        close(1)

       end

c**********************************************

       subroutine wnum(freq,h,wn)
        
       real freq,h,wl, g, pi, tmp2, om, dtmp1, itfrac
       real tmp1
          
       integer k

       g = 9.806
       pi = 3.141592654
       om = 2.*pi*freq
       itfrac = 0.8

       wn = om**2/( g*sqrt( tanh(om**2*h) ) )

       do k = 1, 5

c        print *, k

        tmp2 = wn*h    
        tmp1 = om**2 - g*wn*tanh(tmp2)
        dtmp1 = - g*tanh(tmp2) 
     &        - g*tmp2/cosh(tmp2)**2
        wn = wn - itfrac *tmp1/dtmp1

c        print *, wn

       end do
      
c       print *, sqrt( g*wn*tanh(wn*h) )

       end
c**********************************8

     

          
          




