c--- File with commands common to all routines -----

c      implicit undefined (a-z)
      integer nxm, nym, nmax, nsensor
      parameter (nxm = 300, nym = 300, nmax=300, nsensor=20)

c--- Common variables ------------------------------------------------

      common/bath/ht, depthmax, slope, depthmin,httide
     .      /beta_char/betan, bnm2, bnm1
     .      /boundaries/ibc1, ibc2, ibc3, ibc4, iperx, ipery
     .      /break/Hbr, ibr, ibrk
     .      /depvars/zetan, qxn, qyn
     .      /explcont/cn, cnm1, cnm2
     .      /explxmom/mxn, mxnm1, mxnm2
     .      /explymom/myn, mynm1, mynm2
     .      /grids/x ,y, xsensor, ysensor,yprofile,jump
     .      /initial/kold_start, interval, delay
     .      /initsetup/setup
     .      /longwave/alpha, k, ampli, wlec, sigma
     .      /math/pi,kounter
     .      /numscheme/cr, dx, dy, dt,nx,nxwall,ny,ntime,nxa,ts
     .      /physical/g,rho,rhod,vtshear,mdiss, vtnormal,fcw,fcwij,Cs
     .      /shear/velocity,disp3d
     .      /filter/nxorder,nyorder,nfilter1,nfilter2,iqxfilter,
     .                iqyfilter,izxfilter,izyfilter
     .      /shortwave/H,theta,costh,sinth,u0,period,c_sw,Qw,qwx,qwy,
     .            wavek,shwave_force_x,shwave_force_y,dissipation,
     .		  Bo,amerge,wc
     .      /uday/hto
     .      /visco/v_t, vt_normal
     .      /xmom/dSxxdxn, dhodxn, dSxydyn
     .      /ymom/dSxydxn, dhodyn, dSyydyn
     .      /U_parameters/a1x,b1x,c1x,d1x,d2x,e1x,f1x,f2x,fs1x
     .      /V_parameters/a1y,b1y,c1y,d1y,d2y,e1y,f1y,f2y,fs1y 
     .      /u1_parameters/uda4,uda3,uda2,udb4,udb3,udb2,
     .		udw4,udw3,udw2,udc
     .      /v1_parameters/vda4,vda3,vda2,vdb4,vdb3,vdb2,
     .		vdw4,vdw3,vdw2,vdc
     .      /streaming/tauss_x, tauss_y
     .      /wind/wind_vel,wind_dir
     .      /outputSC/tavgout,momout,dispout
     .      /timeaverage/adqxdx, adqydy, africtx,
     . adtaudy, adzdx, aqxqxdx,
     . aqxqydy, adispx, africty,
     . adtaudx, adzdy, aqyqydy, 
     . aqxqydx, adispy,
     . azeta, aqxn, aqyn,average

      real*8
     . average, adqxdx(nxm,nym), adqydy(nxm,nym), africtx(nxm,nym),
     . adtaudy(nxm,nym), adzdx(nxm,nym), aqxqxdx(nxm,nym),
     . aqxqydy(nxm,nym), adispx(nxm,nym), africty(nxm,nym),
     . adtaudx(nxm,nym), adzdy(nxm,nym), aqyqydy(nxm,nym), 
     . aqxqydx(nxm,nym), adispy(nxm,nym),
     . azeta(nxm,nym), aqxn(nxm,nym), aqyn(nxm,nym),
     . cr, dx, dy, dt,amerge,httide,
     . alpha(nxm), k(nxm), ampli, wlec, sigma,
     . H(nxm,nym), theta(nxm,nym), u0(nxm,nym), period, c_sw(nxm,nym),
     . costh(nxm,nym), sinth(nxm,nym),wavek(nxm,nym),
     . Qw(nxm,nym), qwx(nxm,nym), qwy(nxm,nym), Bo,
     . shwave_force_x(nxm,nym), shwave_force_y(nxm,nym),  
     . ht(nxm,nym), depthmax, slope, x(nxm), y(nym), depthmin,
     . g, rho,rhod, vtshear,mdiss,Cs,vtnormal,fcw,pi,fcwij(nxm,nym),
     . zetan(nxm,nym), qxn(nxm,nym), qyn(nxm,nym),
     . cn(nxm,nym), cnm1(nxm,nym), cnm2(nxm,nym),
     . mxn(nxm,nym), mxnm1(nxm,nym), mxnm2(nxm,nym),
     . myn(nxm,nym), mynm1(nxm,nym), mynm2(nxm,nym),
     . dSxxdxn(nxm,nym), dhodxn(nxm,nym), dSxydyn(nxm,nym),
     . dSxydxn(nxm,nym), dhodyn(nxm,nym), dSyydyn(nxm,nym),
     . betan(3,nym), bnm2(nym), bnm1(nym),
     . sperre, idel, delay,dissipation(nxm,nym),
     . Hbr, setup(nxm,nym),
     . v_t(nxm,nym), vt_normal(nxm,nym),
     . velocity(nxm), hto(nxm,nym),
     . a1x(nxm,nym), b1x(nxm,nym), c1x(nxm,nym),d1x(nxm,nym), 
     . d2x(nxm,nym), e1x(nxm,nym),f1x(nxm,nym), f2x(nxm,nym),
     . fs1x(nxm,nym),
     . a1y(nxm,nym), b1y(nxm,nym),c1y(nxm,nym),d1y(nxm,nym), 
     . d2y(nxm,nym), e1y(nxm,nym),f1y(nxm,nym),f2y(nxm,nym),
     . fs1y(nxm,nym), wind_vel,wind_dir,
     . tauss_x(nxm,nym), tauss_y(nxm,nym),
     . uda4(nxm,nym),uda3(nxm,nym),uda2(nxm,nym),udb4(nxm,nym),
     . udb3(nxm,nym),udb2(nxm,nym),
     . udw4(nxm,nym),udw3(nxm,nym),udw2(nxm,nym),udc(nxm,nym), 
     . vda4(nxm,nym),vda3(nxm,nym),vda2(nxm,nym),vdb4(nxm,nym),
     . vdb3(nxm,nym),vdb2(nxm,nym),
     . vdw4(nxm,nym),vdw3(nxm,nym),vdw2(nxm,nym),vdc(nxm,nym)

      integer
     . iqxfilter, iqyfilter, nxorder, nyorder,nfilter1, nfilter2,
     . izxfilter, izyfilter,ts,tavgout,momout,dispout,jump,
     . nx, ny, ntime, nxa(nym),nxwall,kounter,
     . ibc1, ibc2, ibc3, ibc4, iperx, ipery,
     . kold_start, interval,wc,disp3d,yprofile(8),
     . ibr(nym), ibrk(nxm,nym), xsensor(nsensor), ysensor(nsensor)

