c234567
      subroutine CircModule()
      include 'pass.h'
      
      pi=4.*atan(1.)
      
      dt=Master_dt
      if(Master_Start.eq.1) then
       time=0.
      else
       time=Time_Master
      endif
      ntim=int(time/dt)
      
      xntim=100.
      xbeg=50.
      
      if(time.gt.xbeg.and.time.lt.(xbeg+xntim)) then
       dcu=0.3*(sin(2*pi*(time-xbeg)/(4.*xntim))**2)
       write(*,*)'Starting at time=',time
      elseif(time.ge.(xbeg+xntim)) then
        dcu=0.3
	write(*,*)'Now constant u', time
      else
        dcu=0.
      endif
	 
      do i=1,Nx_Circ
       do j=1,Ny_Circ

         Pass_U(i,j)=dcu*exp(-30.*(X_Circ(i,j)-150.)**2/(200.**2)
     &    -30.*(Y_Circ(i,j)-100.)**2/(150.**2))
         Pass_V(i,j)=0.

       enddo
      enddo

      print*, 'Circulation module', time,' dcu=',dcu
      
      return
      end
      
