c-----This portion of code contains common statements 
c     that are used in many subroutines

      implicit integer(n)
      include 'parameter.inc'    

c-----variable definitions

      common/tim/number,ntime,ntim,nfirst,nlevel
      common/tim2/time,dt,dtinv,dtint,dtints

      common/unknowns/en(nxp,nyp),kx(nxp,nyp),ky(nxp,nyp)
      common/variables/u(nxp,nyp),v(nxp,nyp),d(nxp,nyp),eta(nxp,nyp),
     &waveh(nxp,nyp),zeta(nyp),beta(nyp)
      common/rhs/fen(nxp,nyp,4),fkx(nxp,nyp,4),fky(nxp,nyp,4)
      
      common/current/ux(nxp,nyp),vx(nxp,nyp),uy(nxp,nyp),vy(nxp,nyp)

      common/derkin/sigmax(nxp,nyp),sigmay(nxp,nyp),kxx(nxp,nyp),
     &kyx(nxp,nyp)
 
      common/shortw/wh,th0,omega,kxb(nyp),kyb(nyp)

      common/depth/h(nxp,nyp),hx(nxp,nyp),hy(nxp,nyp)

      common/trans/x(nxp),y(nyp),phix(nxp),xi(nxp,nyp)

      common/avunknowns/bigkx(nxp),bigky(nxp)

      common/shore1/phit(nxp,nyp),phixi(nxp,nyp),phiy(nxp,nyp)
      common/shore2/zetay(nyp),betay(nyp)

      common/morefun/an(nxp,nyp), bn(nxp,nyp),cn(nxp,nyp)

      common/filty/yw(ny+2),yyw(ny+2),ykx(ny+2),yykx(ny+2),
     &yky(ny+2),yyky(ny+2)

      common/filtx/xd(nxp),xxd(nxp),xkx(nxp),xxkx(nxp),xky(nxp)
     &,xxky(nxp)

      common/ref/k(nxp,nyp),sn(nxp,nyp),cs(nxp,nyp)
      common/speeds/c(nxp,nyp),cg(nxp,nyp),nkh(nxp,nyp),sigma(nxp,nyp),
     &gn(nxp,nyp)
      common/radstress/sxx(nxp,nyp),sxy(nxp,nyp),syy(nxp,nyp)
      
      common/break/fbar,capb,gamma
      common/bdiss/epsb(nxp,nyp)

      common/derb/bx(nxp,nyp),by(nxp,nyp),b4(nyp),by4(nyp)
      common/derxen/en1(nxp,nyp),enx(nxp,nyp),enb1(nxp,nyp),
     &enax(nxp,nyp),enbx(nxp,nyp)
      common/deryen/en2(nxp,nyp),eny(nxp,nyp)
      common/edge/wkedge,alphaz(nyp)
     &,alphab(nyp),xstar(nyp),alphazy(nyp),alphaby(nyp)
      common/domain/lx,ly
      common/switch/icase,iwall,iwc,nc

      common/readzb/zz(nrs),bb(nrs)
      
      common/tout/nloc,xloc(npo),yloc(npo),xpos(npo),ypos(npo),
     &whloc1(npo),
     &sigmaloc1(npo),xkxloc1(npo),xkyloc1(npo),nypos(npo),iloc(nyp)

      common/jenswitches/ddy_sw, ic_sw, order_sw
      
      integer number,ntime,ntim,nfirst,nlevel
      real time,dt,dtinv,dtint,dtints

      real en,kx,ky
      real u,v,d,eta,waveh,zeta,beta
      real fen,fkx,fky
      real ux,uy,vx,vy
      real sigmax,sigmay,kxx,kyx

      real wh,th0,omega,kxb,kyb
      real h,hx,hy
      real x,y,phix,xi

      real bigkx,bigky

      real phit,phixi,phiy
      real zetay,betay
      real an,bn,cn

      real yw,yyw,ykx,yykx,yky,yyky
      real xd,xxd,xkx,xxkx,xky,xxky

      real k,sn,cs
      real c,cg,nkh,sigma,gn
      real sxx,sxy,syy
      
      real fbar,capb,gamma
      real epsb

      real bx,by,b4,by4
      real en1,enx,enb1,enax,enbx
      real en2,eny
      real wkedge,alphaz,alphab,xstar,alphazy,alphaby
      real lx,ly
      integer icase,iwall,iwc,nc

      real zz,bb
      
      integer nloc,nypos,iloc
      real xloc,yloc,xpos,ypos,uloc1,vloc1,etaloc1,hloc1,whloc1,
     &sigmaloc1,xkxloc1,xkyloc1
      
      real pi,g,rho
      integer i,j

      integer ddy_sw, ic_sw, order_sw
