c23456789012345678901234567890123456789012345678901234567890123456789012
c #####################################################################
c TIME MODEL
      subroutine time_model
c     includes 3-D dispersion coded by KAH 
c	LAST MODIFICATION:						
c	- Jan 20, 2002							
c	Version 2.0                                                   
c #####################################################################
CDIR$ FLOW
      include 'winc_std_common.inc'
      include 'pass.h'

c--- Local functions -------------------------------------------------
      real*8 cel, ux, uy, force_xx, force_xy,
     . force_yx, force_yy, wind_x, wind_y

c--- Local variables -------------------------------------------------
      integer ncode,nord, itstep, jj,
     . nxaold1, m, nxaold, nxflag, iunit
     
      character*3 name1,name2(100),name3(100)

      real*8 h1, z1, t, qx1, qy1,
     . qxqy(nxm,nym), qxqx(nxm,nym), qyqy(nxm,nym),
     . qxqxdx(nxm,nym), qxqydx(nxm,nym), 
     . qyqydy(nxm,nym), qxqydy(nxm,nym), 
     . qwxqwy(nxm,nym), qwxqwx(nxm,nym), qwyqwy(nxm,nym),
     . qwxqwxdx(nxm,nym), qwxqwydx(nxm,nym), 
     . qwyqwydy(nxm,nym), qwxqwydy(nxm,nym), 
     . dqxdxn(nxm,nym),vtsum(nxm,nym),dvtsumdx(nxm,nym),
     . dqydyn(nxm,nym),  dvtsumdy(nxm,nym),
     . dzetadxn(nxm,nym), dzetadyn(nxm,nym),
     . frictx(nxm,nym), fricty(nxm,nym),
     . fake(nxm,nym), fake1(nxm,nym), fake2(nxm,nym),
     . coeff1(10), coeff2(10), denom1, denom2,
     . betanp1(3,nym), bn(nym), bstar(nym),
     . zetaup, qxup, qyup, bnup, vert,
     . zetanp1(nxm,nym), qxnp1(nxm,nym), qynp1(nxm,nym),
     . Qi, qxr, alphanew, alpha2(nym),
     . dzetadxstar(nxm,nym), dzetadystar(nxm,nym),
     . dqxdxstar(nxm,nym), dqydystar(nxm,nym),
     . momxstar(nxm,nym), momystar(nxm,nym),
     . momxn(nxm,nym), momyn(nxm,nym),dtauyydy(nxm,nym),
     . cstar(nxm,nym), mxstar(nxm,nym), mystar(nxm,nym),
     . dtauxydx(nxm,nym),tauxx(nxm,nym),tauyy(nxm,nym),
     . dtauxydy(nxm,nym), tauxy(nxm,nym), dtauxxdx(nxm,nym),
     . aux(nmax+1), aux2(nmax+1), aux3(nmax+1), aux4(nmax+1),
     . aux5(nmax+1), aux6(nmax+1), aux1, mass0, energy0,
     . mass, energy, qxtotal, qytotal, xfluxin, yfluxin,
     . V1, V2, dx2, dx3(nym), dx3star(nym), qxstar(nym), qystar(nym),
     . zeta_x, z_x, argument1, argument2, factor,
     . ds(nym), ddsdyn(nym), dsstar(nym), ddsdystar(nym),
     . wind_angle, windx, windy, cd, 
     . Dxx(nxm,nym), Dxy(nxm,nym), Dyy(nxm,nym),dVo_dxdy(nxm,nym),
     . Mxx(nxm,nym), Mxy(nxm,nym), Myy(nxm,nym), dMxx_dx(nxm,nym),
     . dMxy_dx(nxm,nym), dMxy_dy(nxm,nym), dMyy_dy(nxm,nym),
     . disp1(nxm,nym), disp2(nxm,nym), disp3(nxm,nym),
     . disp1_dx(nxm,nym), disp2_dx(nxm,nym), disp2_dy(nxm,nym),
     . disp3_dy(nxm,nym), dispx(nxm,nym), dispy(nxm,nym),
     . htot, ht2, ht3, ht4,  dUo_dy2(nxm,nym),dUo_dxdy(nxm,nym),
     . Uo(nxm,nym), Vo(nxm,nym), dUo_dx(nxm,nym), dUo_dy(nxm,nym), 
     . dVo_dx(nxm,nym), dVo_dy(nxm,nym), qyb3(nxm), qyb4(nxm),
     . Axxx(nxm,nym), Axxy(nxm,nym), Axyx(nxm,nym), Axyy(nxm,nym), 
     . Ayyx(nxm,nym), Ayyy(nxm,nym), dVo_dx2(nxm,nym), dVo_dy2(nxm,nym),
     . Bxx(nxm,nym), Bxy(nxm,nym), Byy(nxm,nym),dUo_dx2(nxm,nym),
     . adv1(nxm,nym), adv2(nxm,nym), adv3(nxm,nym), adv3_dy(nxm,nym),
     . adv1_dx(nxm,nym), adv2_dx(nxm,nym), adv2_dy(nxm,nym),
c     . average, adqxdx(nxm,nym), adqydy(nxm,nym), africtx(nxm,nym),
c     . adtaudy(nxm,nym), adzdx(nxm,nym), aqxqxdx(nxm,nym),
c     . aqxqydy(nxm,nym), adispx(nxm,nym), africty(nxm,nym),
c     . adtaudx(nxm,nym), adzdy(nxm,nym), aqyqydy(nxm,nym), 
c     . aqxqydx(nxm,nym), adispy(nxm,nym),
     . vs(nxm,nym), 
c     . azeta(nxm,nym), aqxn(nxm,nym), aqyn(nxm,nym),
     . inv_ht, htt(nxm,nym), inv_denom1, inv_denom2, inv_average


c=====================================================================
c ## define functions that will be used through out the routine -----
c
c ## WARNING: they look like variables but behave like functions,
c ## and must follow imediately the dimension statements
c----------------------------------------------------------------------

      cel(h1,z1) = DSQRT(g*(h1+z1))
      ux(qx1,z1,h1) = qx1/(h1+z1)
      uy(qy1,z1,h1) = qy1/(h1+z1)
      force_xx(i,j,t)= DTANH(t*delay)*dSxxdxn(i,j)
      force_xy(i,j,t)= DTANH(t*delay)*dSxydyn(i,j)
      force_yx(i,j,t)= DTANH(t*delay)*dSxydxn(i,j)
      force_yy(i,j,t)= DTANH(t*delay)*dSyydyn(i,j)
      wind_x(t) = DTANH(t*delay)*windx
      wind_y(t) = DTANH(t*delay)*windy

c----------------------------------------------------------------------
c      write(*,903)' Start time model'
c ## default filter parameters 
      if (ipery.eq.1.) then
        iqyfilter=5
        izyfilter=5
      else
        iqyfilter=6
        izyfilter=2
      end if
      izxfilter=6
      iqxfilter=6
      nxorder=16
      nyorder=16
      nfilter1 = 1
      nfilter2 = 1
c----------------------------------------------------------------------
c ## get coefficients for scheme 

      nord = 2
      call predcor(nord,coeff1,coeff2,denom1,denom2)
      inv_denom1 = 1.d0/denom1*dt
      inv_denom2 = 1.d0/denom2*dt

c----------------------------------------------------------------------
c ## initialize array and read Longshore velocities at boundaries 3&4
      do j=1,ny
        dx3(j) = dx
      end do

      if (ibc3.eq.1) then
         open(unit=14, file='qyb3.in', status='old')
         do i=1,nx
           read(14,*) qyb3(i)
         end do
         write(6,905) (qyb3(i),i=1,nx)
      end if
      if (ibc4.eq.1) then
         open(unit=15, file='qyb4.in', status='old')
         do i=1,nx
           read(15,*)qyb4(i)
         end do
         write(6,905) (qyb4(i),i=1,nx)
      end if

c----------------------------------------------------------------------
c ## Calculate initial mass, energy 
      mass=0.d0
      energy=0.d0
      do j=1,ny
        do i=1,nx
	  energy = 0.5d0*( zetan(i,j)*zetan(i,j)-ht(i,j)*ht(i,j)
     .		+(qxn(i,j)*qxn(i,j)+qyn(i,j)*qyn(i,j))
     .		/(g*(ht(i,j)+zetan(i,j))) ) + energy
        end do
      end do
c
c	calculate mass based on the trapezoidal rule
c
	mass=.25d0*(zetan(1,1)+zetan(1,ny)+zetan(nx,1)+zetan(nx,ny)
     . 		+ht(1,1)+ht(1,ny)+ht(nx,1)+ht(nx,ny))
	do j=2,ny-1
	  mass=mass+(zetan(1,j)+zetan(nx,j)+ht(1,j)+ht(nx,j))*.5d0
	  do i=2,nx-1
	    mass =mass+zetan(i,j)+ht(i,j)
	  end do
	end do

	do i=2,nx-1
	  mass=mass+(zetan(i,1)+zetan(i,ny)+ht(i,1)+ht(i,ny))*.5d0
	end do
	mass=mass*dx*dy

      mass0=mass
      energy0=energy

c----------------------------------------------------------------------
c ## Calculate wind shear stress

      wind_angle = wind_dir*pi/180.d0
      cd = 1.3915d-3
      windx = 1.2/rho*cd*wind_vel*wind_vel*dcos(wind_angle)
      windy = -1.2/rho*cd*wind_vel*wind_vel*dsin(wind_angle)
 
c----------------------------------------------------------------------
c ## set averages to zero
      if (time_master.le.5.d0/delay) then
        do j = 1,ny
          do i=1,nx
            adqxdx(i,j) = 0.d0
            adqydy(i,j) = 0.d0
            africtx(i,j) = 0.d0
            adtaudy(i,j) = 0.d0
            adzdx(i,j) = 0.d0
            aqxqxdx(i,j) = 0.d0
            aqxqydy(i,j) = 0.d0
            adispx(i,j) = 0.d0
            africty(i,j) = 0.d0
            adtaudx(i,j) = 0.d0
            adzdy(i,j) = 0.d0
            aqyqydy(i,j) = 0.d0
            aqxqydx(i,j) = 0.d0
            adispy(i,j) = 0.d0
            azeta(i,j) = 0.d0
            aqxn(i,j) = 0.d0
            aqyn(i,j) = 0.d0
          end do
        end do
        end if
c----------------------------------------------------------------------
c ## Start Time Loop
c----------------------------------------------------------------------
c      write(6,*) 'Start Time Loop'
c      kounter=0
c      t = 0.d0
c      average = 0.d0
      t = time_master

      do itstep = 1,ntime
c     increment total times by 1
         ts=ts+1
      if (mod(ts,10).eq.0) write(6,*) 'SC step', ts
c  Recalculate the forcing every wc time steps
c        if(wc.eq.0) goto 5
cc        if (wc.ne.0.and.mod(itstep,wc).eq.0) then
c         if (mod(itstep,wc).eq.0) then
c	  write(*,*)'recalculating forcing'
c	  call shortwave_driver
c          call wave_forcing
c	end if
c 5      continue
c----------------------------------------------------------------------
c ## Compute RHS at time at predictor-level
c----------------------------------------------------------------------

      ncode =1
      nxflag=1
      call deriv(zetan,qxn,qyn,dzetadxn,dzetadyn,dqxdxn,dqydyn,
     .           ncode,nxflag)

c      write(*,*)qxn(1,1),zetan(1,1)

      if ((ibc1.eq.4)) then
         do j = 1,ny
	  dzetadxn(1,j)=0.d0
         end do
      end if
      if ((ibc2.eq.4.or.ibc2.eq.6)) then
         do j = 1,ny
	  dzetadxn(nxa(j),j)=0.d0
         end do
      end if
      if ((ibc3.eq.4)) then
         do i = 1,nx
	  dzetadyn(i,1)=0.d0
         end do
      end if
      if ((ibc4.eq.4)) then
         do i = 1,nx
	  dzetadyn(i,ny)=0.d0
         end do
      end if

      do j=1,ny
        do i=1,nx
          htot = ht(i,j) + zetan(i,j)
          htt(i,j) = htot
          inv_ht = 1.d0/htot
          qxqx(i,j) = qxn(i,j)*qxn(i,j)*inv_ht
          qxqy(i,j) = qxn(i,j)*qyn(i,j)*inv_ht
          qyqy(i,j) = qyn(i,j)*qyn(i,j)*inv_ht
          Uo(i,j) = ux(qxn(i,j),ht(i,j),zetan(i,j))
          Vo(i,j) = uy(qyn(i,j),ht(i,j),zetan(i,j))
	  qwxqwy(i,j)=qwx(i,j)*qwy(i,j)*inv_ht
	  qwyqwy(i,j)=qwy(i,j)*qwy(i,j)*inv_ht
	  qwxqwx(i,j)=qwx(i,j)*qwx(i,j)*inv_ht
        end do
      end do

      ncode =1
      nxflag=1
      call deriv(qxqy,qxqx,qyqy,qxqydx,qxqydy,qxqxdx,qyqydy,
     .		 ncode,nxflag)

      ncode =3
      nxflag=1
      call deriv(qwxqwy,qwxqwx,qwyqwy,qwxqwydx,qwxqwydy,
     .			qwxqwxdx,qwyqwydy,ncode,nxflag)

      call average_3ptx(nx,ny,qwxqwxdx)  
      call average_3ptx(nx,ny,qwxqwydx)  
      call average_3ptx(nx,ny,qwxqwydy)  
      call average_3ptx(nx,ny,qwyqwydy)  
      call average_3pty(nx,ny,qwxqwxdx)  
      call average_3pty(nx,ny,qwxqwydx)  
      call average_3pty(nx,ny,qwxqwydy)  
      call average_3pty(nx,ny,qwyqwydy)  

c ## call bottom friction ---------------------------------------------

      factor=DTANH(t*delay)
      call bottom_friction(zetan,qxn,qyn,frictx,fricty,
     .                     factor,itstep)

      ncode =3
      nxflag=1
      call deriv(Uo, Vo, Vo, dUo_dx, dUo_dy, dVo_dx, dVo_dy,
     .           ncode,nxflag)


c ## eddy viscosity ---------------------------------------------------
cksm     include the effect of SGS Turbulence using the
c     Smagorinsky eddy viscosity model

      do j=1,ny
	 do i=1,nxa(j)
            vs(i,j)=Cs*Cs*dx*dy*sqrt(dUo_dx(i,j)*dUo_dx(i,j)*2.d0
     .           +dVo_dy(i,j)*dVo_dy(i,j)*2.d0
     .           +(dUo_dy(i,j)+dVo_dx(i,j))*(dUo_dy(i,j)+dVo_dx(i,j)))
	    vtsum(i,j) = (v_t(i,j)+vs(i,j))*(ht(i,j)+zetan(i,j))
	 end do
	 do i=nxa(j)+1,nx
            vs(i,j)=0.d0
	 end do	 
      end do

      call deriv(vtsum,tauxx,tauyy,dvtsumdx,dvtsumdy,dtauxxdx,
     .            dtauyydy,3,nxflag)

      call deriv(Uo, Vo, Vo, dUo_dx2, dUo_dy2, dVo_dx2, dVo_dy2,
     .           4,nxflag)

      call dmixed(Uo, Vo, dUo_dxdy, dVo_dxdy,
     .           nxflag)

       do j=1,ny
 	 do i=1,nxa(j)

             dtauxxdx(i,j)=dvtsumdx(i,j)*
     .			 (dUo_dx(i,j)+dUo_dx(i,j))
     .          +(v_t(i,j)+vs(i,j))*(ht(i,j)+zetanp1(i,j))
     .           *(dUo_dx2(i,j)+dUo_dx2(i,j))

             dtauyydy(i,j)=dvtsumdy(i,j)*
     .			 (dVo_dy(i,j)+dVo_dy(i,j))
     .          +(v_t(i,j)+vs(i,j))*(ht(i,j)+zetanp1(i,j))
     .           *(dVo_dy2(i,j)+dVo_dy2(i,j))

             dtauxydx(i,j)=dvtsumdx(i,j)*
     .			 (dVo_dx(i,j)+dUo_dy(i,j))
     .          +(v_t(i,j)+vs(i,j))*(ht(i,j)+zetan(i,j))*
     .           (dVo_dx2(i,j)+dUo_dxdy(i,j))

             dtauxydy(i,j)=dvtsumdy(i,j)*
     .			 (dVo_dx(i,j)+dUo_dy(i,j))
     .          +(v_t(i,j)+vs(i,j))*(ht(i,j)+zetan(i,j))
     .            *(dUo_dy2(i,j)+dVo_dxdy(i,j))
  	 end do	 
 	 do i=nxa(j),nx
             dtauxxdx(i,j)=0.d0
             dtauyydy(i,j)=0.d0
             dtauxydx(i,j)=0.d0
             dtauxydy(i,j)=0.d0
  	 end do	 
       end do

c ## 3D dispersion, coded by KAH for Ap's reduced version ------------------

      if(disp3d.eq.0) then
         do j=1,ny
           do i=1,nx
             dispx(i,j)=0.d0
             dispy(i,j)=0.d0
             fs1x(i,j)=0.d0
             fs1y(i,j)=0.d0
             f2x(i,j)=0.d0
             f2y(i,j)=0.d0
             udc(i,j)=0.d0
             vdc(i,j)=0.d0
           end do
         end do
         goto 554
      end if

        call UV_profile(zetan,frictx,fricty,t,windx,windy,vs)
        call coefcalc(Dxx,Dyy,Dxy,zetan,Mxx,Myy,Mxy,Bxx,Bxy,Byy,
     .       Axxx,Axxy,Axyx,Axyy,Ayyx,Ayyy,vs,Uo,Vo)

      do j=1,ny
	 do i=1,nxa(j)
           htot = ht(i,j) + zetan(i,j)
           ht2 = htot*htot
           ht3 = ht2*htot
           ht4 = ht2*ht2
           adv1(i,j) = Axxx(i,j)*Uo(i,j)+Axxy(i,j)*Vo(i,j)    
           adv2(i,j) = Axyx(i,j)*Uo(i,j)+Axyy(i,j)*Vo(i,j)
           adv3(i,j) = Ayyx(i,j)*Uo(i,j)+Ayyy(i,j)*Vo(i,j) 
           disp1(i,j) = ( (2.d0*Dxx(i,j)+Bxx(i,j))*dUo_dx(i,j)
     .                  +2.d0*Dxy(i,j)*dUo_dy(i,j)
     .                  +Bxx(i,j)*dVo_dy(i,j))*htot
           disp2(i,j) = ( Dxx(i,j)*dVo_dx(i,j)
     .                  +(Dxy(i,j)+Bxy(i,j))*dVo_dy(i,j)
     .                  +(Dxy(i,j)+Bxy(i,j))*dUo_dx(i,j)
     .                  + Dyy(i,j)*dUo_dy(i,j)
     .                  )*htot
           disp3(i,j) = ( 2.d0*Dxy(i,j)*dVo_dx(i,j)
     .                  +(2.d0*Dyy(i,j)+Byy(i,j))*dVo_dy(i,j)
     .                  +(Byy(i,j))*dUo_dx(i,j)
     .                  )*htot
	 end do	 
	 do i=nxa(j)+1,nx
           disp1(i,j) = 0.d0
           disp2(i,j) = 0.d0
           disp3(i,j) = 0.d0
	 end do	 
      end do
      ncode =3
      nxflag=1
      call deriv(disp2, disp1, disp3, disp2_dx, disp2_dy, disp1_dx,
     .		 disp3_dy, ncode, nxflag)
      call deriv(Mxy, Mxx, Myy, dMxy_dx, dMxy_dy, dMxx_dx,
     .		 dMyy_dy, ncode, nxflag)
      call deriv(adv2, adv1, adv3, adv2_dx, adv2_dy, adv1_dx,
     .           adv3_dy, ncode, nxflag)
c ## do 3pt-average of terms in dispx ------------------
      call average_3ptx(nx,ny,disp1_dx)
      call average_3ptx(nx,ny,disp2_dy)

c ## do 3pt-average of terms in dispy ------------------
      call average_3ptx(nx,ny,disp2_dx)
      call average_3ptx(nx,ny,disp3_dy)

c ## assemble the dispersion terms ----------- 
      do j=1,ny
	 do i=1,3
           dispx(i,j) = 0.d0
           dispy(i,j) = 0.d0
           qwxqwxdx(i,j) = 0.d0
           qwxqwydy(i,j) = 0.d0
           qwxqwydx(i,j) = 0.d0
           qwyqwydy(i,j) = 0.d0
	 end do	 
	 do i=4,nxa(j)
           dispx(i,j) = disp1_dx(i,j) + disp2_dy(i,j) 
     .           -dMxx_dx(i,j)-dMxy_dy(i,j)
     .           -adv1_dx(i,j)-adv2_dy(i,j)
           dispy(i,j) = disp2_dx(i,j) + disp3_dy(i,j)
     .          -dMyy_dy(i,j)-dMxy_dx(i,j)
     .          -adv2_dx(i,j)-adv3_dy(i,j)
	 end do	 
	 do i=nxa(j)+1,nx
           dispx(i,j) = 0.d0
           dispy(i,j) = 0.d0
           qwxqwxdx(i,j) = 0.d0
           qwxqwydy(i,j) = 0.d0
           qwxqwydx(i,j) = 0.d0
           qwyqwydy(i,j) = 0.d0
	 end do	 
      end do
c ## do 3pt-average of dispx and dispy ------------------
      call average_3ptx(nx,ny,dispx)
      call average_3pty(nx,ny,dispx)
      call average_3ptx(nx,ny,dispy)
      call average_3pty(nx,ny,dispy)
ckk 12/16/99
      do j=1,ny
	 do i=1,nx
          qwxqwxdx(i,j)=qwxqwxdx(i,j)
     .           *dtanh((dble((nx-i)/dble(nx))/.02d0)**4)
          qwxqwydy(i,j)=qwxqwydy(i,j)
     .           *dtanh((dble((nx-i)/dble(nx))/.02d0)**4)
          qwxqwydx(i,j)=qwxqwydx(i,j)
     .           *dtanh((dble((nx-i)/dble(nx))/.02d0)**4)
          qwyqwydy(i,j)=qwyqwydy(i,j)
     .           *dtanh((dble((nx-i)/dble(nx))/.02d0)**4)
          dispx(i,j)=dispx(i,j)*dtanh((dble((nx-i)/dble(nx))/.02d0)**4)
          dispy(i,j)=dispy(i,j)*dtanh((dble((nx-i)/dble(nx))/.02d0)**4)
	 end do	 
      end do
ckk 12/16/99
554   continue

c ## calculate RHS of continuity & momentum eqs' ----------------------
c ## predictor-level
      factor=DTANH(t*delay*0.5d0)

      do j = 1,ny
        do i = 1,nxa(j)

          cn(i,j) = - (dqxdxn(i,j) + dqydyn(i,j))

          momxn(i,j) = 0.d0
     .    - force_xx(i,j,t) 
     .    - force_xy(i,j,t)
     .    - frictx(i,j)
     .    + dtauxydy(i,j)
     .    + dtauxxdx(i,j)
     .    + wind_x(t)

          mxn(i,j) = momxn(i,j)
     .    - g*htt(i,j)*dzetadxn(i,j)
     .    - qxqxdx(i,j) -qxqydy(i,j)
     .    + dispx(i,j)*factor
c     .    + (qwxqwxdx(i,j))*factor
     .    + (qwxqwxdx(i,j) +qwxqwydy(i,j))*factor

          momyn(i,j) =  0.d0
     .    - force_yx(i,j,t) 
     .    - force_yy(i,j,t)
     .    - fricty(i,j)
     .    + dtauxydx(i,j)
     .    + dtauyydy(i,j)
     .    + wind_y(t)

          myn(i,j) = momyn(i,j)
     .    - g*htt(i,j)*dzetadyn(i,j)
     .    - qyqydy(i,j) -qxqydx(i,j)
     .    + dispy(i,j)*factor
c     .    + (qwyqwydy(i,j))*factor
     .    + (qwxqwydx(i,j) +qwyqwydy(i,j))*factor

        end do
      end do


         do j = 1,ny
            do i=nxa(j)+1,nx
              cn(i,j)=0.d0
              momxn(i,j)=0.d0
              mxn(i,j)=0.d0
              momyn(i,j)=0.d0
              myn(i,j)=0.d0
            end do
         end do


c----------------------------------------------------------------------
c ## Characteristix on x=0 

      if ((ibc1.eq.2).or.(ibc1.eq.3))
     . call betachar(bn,betan,zetan,qxn,qyn,dqydyn,dzetadyn,momxn)

c----------------------------------------------------------------------
c ## The Predictor Step
c----------------------------------------------------------------------
         do i = 1,nx
            do j = 1,ny

              zetaup = coeff1(1)*cn(i,j) + coeff1(2)*cnm1(i,j) +
     .                 coeff1(3)*cnm2(i,j)
              qxup = coeff1(1)*mxn(i,j) + coeff1(2)*mxnm1(i,j) +
     .                 coeff1(3)*mxnm2(i,j)
              qyup = coeff1(1)*myn(i,j) + coeff1(2)*mynm1(i,j) +
     .                 coeff1(3)*mynm2(i,j)

              zetanp1(i,j) = zetan(i,j) + zetaup*inv_denom1
              qxnp1(i,j)   = qxn(i,j)   + qxup*inv_denom1
              qynp1(i,j)   = qyn(i,j)   + qyup*inv_denom1
 
            end do
         end do
         

c ##   Check for negative water depths 
       do j = 1,ny
        do i = nxa(j)+1,nx
           qxnp1(i,j)=0.d0
           qynp1(i,j)=0.d0
           zetanp1(i,j)=-ht(i,j)+0.0001d0
        end do
       end do


c----------------------------------------------------------------------
c ## Flux Conditions 


      if ((ibc1.eq.2)) then
         do j = 1,ny
              qxnp1(1,j) = 0.d0
         end do
      end if

      if (ibc1.eq.4) then
         do j=1,ny
              qxnp1(1,j) = 0.d0          
         end do
      end if

      if (ibc2.eq.4) then
         do j = 1,ny
              qxnp1(nxa(j),j) = 0.d0
         end do
      end if

      if (ibc2.eq.6) then
         do j = 1,ny
              qxnp1(nxa(j),j) = 0.d0
              qynp1(nxa(j),j) = 0.d0          
         end do
      end if

      if (ibc3.eq.1) then
         do i=1,nx
              qynp1(i,1) = qyb3(i)*factor
         end do
      end if

      if (ibc4.eq.1) then
         do i=1,nx
              qynp1(i,ny) = qyb4(i)*factor
         end do
      end if

      if (ibc3.eq.4) then
         do i=1,nx
              qynp1(i,1) = 0.d0
         end do
      end if

      if (ibc4.eq.4) then
         do i=1,nx
              qynp1(i,ny) = 0.d0
         end do
      end if
      if (ibc3.eq.5.and.ibc4.eq.5) then
         do i=1,nx
              qynp1(i,1) = qynp1(i,ny)
              qxnp1(i,1) = qxnp1(i,ny)
              zetanp1(i,1) = zetanp1(i,ny)
         end do
      end if

c----------------------------------------------------------------------
c ## Absorb/generating cond. at the boundary x=0


      if ((ibc1.eq.2).or.(ibc1.eq.3)) then

        do j=1,ny
      
          bnup = coeff1(1)*bn(j) + coeff1(2)*bnm1(j) +
     . 		coeff1(3)*bnm2(j)
          betanp1(1,j) = betan(1,j)+ bnup*inv_denom1
          alpha2(j)=-alpha(1)
c!!! "vert" is Qyr, the vol. flux of the reflected wave
c!!! "aqy" is the incoming y-volume flux and Qi=aqy !!
c          vert = (qynp1(1,j)-aqy(x(1),y(j),t+dt,1))
c          Qi = ampli*dsin(k(1)*dcos(alpha(1))*x(1) 
c     .         + k(1)*dsin(alpha(1))*y(j) - sigma*(t+dt))
c!!! For the case of no incoming waves I simplify "vert, Qi" as:
          vert = qynp1(1,j)
          Qi = 0.d0

          aux1 = Qi**2*(.75d0-dcos(alpha(1))) + Qi*DSQRT(g*ht(1,j))*
     . 		ht(1,j)*(dcos(alpha(1))-1.d0)

          do jj=1,50
c---------- Higher order bound. cond. ---
c      	    qxr = dcos(alpha2(j))*(DSQRT(g*ht(1,j))*ht(1,j)
c     .  	*(dcos(alpha2(j))+1.d0)+Qi*(dcos(alpha(1))
c     .		-dcos(alpha2(j))-1.5d0))/(2.d0*dcos(alpha2(j))+1.5d0)
c     .  	*(-1.d0+DSQRT(1.d0-( (4.d0*dcos(alpha2(j))+3.0d0)
c     .  	*(aux1 - (DSQRT(g*ht(1,j))*ht(1,j))**2
c     .  	*(betanp1(1,j)/DSQRT(g*ht(1,j))+2.d0))
c     .  	/(DSQRT(g*ht(1,j))*ht(1,j)*(dcos(alpha2(j))+1.d0)+Qi
c     .  	*(dcos(alpha(1))-dcos(alpha2(j))-1.5d0))**2)))
c---------- Lower order bound. cond. ---
      	    qxr = dcos(alpha2(j))/(dcos(alpha2(j))+1.d0)
     .   	*(ht(1,j)*(betanp1(1,j)+2.d0*DSQRT(g*ht(1,j)))
     .          -Qi*(dcos(alpha(1))-1.d0))

            if (vert.eq.0.d0 .and. qxr.eq.0.d0) then
               alphanew = 0.d0
            else
               alphanew = datan2(vert,qxr)
            end if
      	    if (alphanew .gt. (pi*0.5d0)) alphanew=alphanew-pi
      	    if (alphanew .le. (-pi*0.5d0)) alphanew=alphanew+pi

c---------- Ap's criterion:
c            if (dabs(alphanew-alpha2(j)).le.0.0000001) goto 1000
            if(dabs(alphanew-alpha2(j)).lt.0.001) goto 1000
            alpha2(j) = alphanew

          end do
1000      continue

          qxnp1(1,j) = Qi*dcos(alpha(1)) + qxr

        end do

      end if


c----------------------------------------------------------------------
c ## Calculate RHS at corrector level
c----------------------------------------------------------------------

      ncode =1
      nxflag=1
      call deriv(zetanp1,qxnp1,qynp1,dzetadxstar,dzetadystar,
     .           dqxdxstar,dqydystar,ncode,nxflag)

      if ((ibc1.eq.4)) then
         do j = 1,ny
	  dzetadxstar(1,j)=0.d0
         end do
      end if
      if ((ibc2.eq.4.or.ibc2.eq.6)) then
         do j = 1,ny
	  dzetadxstar(nxa(j),j)=0.d0
         end do
      end if
      if ((ibc3.eq.4)) then
         do i = 1,nx
	  dzetadystar(i,1)=0.d0
         end do
      end if
      if ((ibc4.eq.4)) then
         do i = 1,nx
	  dzetadystar(i,ny)=0.d0
         end do
      end if

      do j=1,ny
        do i=1,nx
          htot = ht(i,j) + zetanp1(i,j)
          htt(i,j) = htot
          inv_ht = 1.d0/htot
          qxqx(i,j) = qxnp1(i,j)*qxnp1(i,j)*inv_ht
          qxqy(i,j) = qxnp1(i,j)*qynp1(i,j)*inv_ht
          qyqy(i,j) = qynp1(i,j)*qynp1(i,j)*inv_ht
          Uo(i,j) = ux(qxnp1(i,j),ht(i,j),zetanp1(i,j))
          Vo(i,j) = uy(qynp1(i,j),ht(i,j),zetanp1(i,j))
        end do
      end do

      ncode =1
      nxflag=1
      call deriv(qxqy,qxqx,qyqy,qxqydx,qxqydy,qxqxdx,qyqydy,
     .		 ncode,nxflag)


c ## call bottom friction  --------------------------------------------

ckk      factor=0.d0
      factor=DTANH(t*delay)
      call bottom_friction(zetanp1,qxnp1,qynp1,frictx,fricty,
     .			   factor,itstep)
      ncode =3
      nxflag=1
      call deriv(Uo, Vo, Vo, dUo_dx, dUo_dy, dVo_dx, dVo_dy,
     .           ncode,nxflag)

c ## eddy viscosity  --------------------------------------------------
c
c     Inculudes the Smagorinsky eddy viscosity (vs)
c

      do j=1,ny
	 do i=1,nxa(j)
            vs(i,j)=Cs*Cs*dx*dy*sqrt(dUo_dx(i,j)*dUo_dx(i,j)*2.d0
     .           +dVo_dy(i,j)*dVo_dy(i,j)*2.d0
     .           +(dUo_dy(i,j)+dVo_dx(i,j))*(dUo_dy(i,j)+dVo_dx(i,j)))

	    vtsum(i,j) = (v_t(i,j)+vs(i,j))*(ht(i,j)+zetanp1(i,j))
         end do
	 do i=nxa(j)+1,nx
            vs(i,j)=0.d0
	 end do	 
      end do

      call deriv(vtsum,tauxx,tauyy,dvtsumdx, dvtsumdy,dtauxxdx,
     .           dtauyydy,3,nxflag)
      call deriv(Uo, Vo, Vo, dUo_dx2, dUo_dy2, dVo_dx2, dVo_dy2,
     .           4,nxflag)
      call dmixed(Uo, Vo, dUo_dxdy, dVo_dxdy,
     .           nxflag)

       do j=1,ny
 	 do i=1,nxa(j)
             dtauxxdx(i,j)=dvtsumdx(i,j)*
     .			 (dUo_dx(i,j)+dUo_dx(i,j))
     .          +(v_t(i,j)+vs(i,j))*(ht(i,j)+zetanp1(i,j))
     .           *(dUo_dx2(i,j)+dUo_dx2(i,j))

             dtauyydy(i,j)=dvtsumdy(i,j)*
     .			 (dVo_dy(i,j)+dVo_dy(i,j))
     .          +(v_t(i,j)+vs(i,j))*(ht(i,j)+zetanp1(i,j))
     .           *(dVo_dy2(i,j)+dVo_dy2(i,j))

             dtauxydx(i,j)=dvtsumdx(i,j)*
     .			 (dVo_dx(i,j)+dUo_dy(i,j))
     .          +(v_t(i,j)+vs(i,j))*(ht(i,j)+zetanp1(i,j))
     .           *(dVo_dx2(i,j)+dUo_dxdy(i,j))

             dtauxydy(i,j)=dvtsumdy(i,j)*
     .			 (dVo_dx(i,j)+dUo_dy(i,j))
     .          +(v_t(i,j)+vs(i,j))*(ht(i,j)+zetanp1(i,j))
     .            *(dUo_dy2(i,j)+dVo_dxdy(i,j))
  	 end do	 
 	 do i=nxa(j),nx
             dtauxxdx(i,j)=0.d0
             dtauyydy(i,j)=0.d0
             dtauxydx(i,j)=0.d0
             dtauxydy(i,j)=0.d0
  	 end do	 
       end do

c ## calculate RHS of continuity & momentum eqs' ----------------------
c ## corrector-level

      factor=DTANH(t*delay*0.5d0)

      do j = 1,ny 
        do i = 1,nxa(j)

           cstar(i,j)  = -(dqxdxstar(i,j) + dqydystar(i,j))

           momxstar(i,j) = 0.d0
     .     - force_xx(i,j,t) 
     .     - force_xy(i,j,t)
     .     - frictx(i,j)
     .     + dtauxydy(i,j)
     .     + dtauxxdx(i,j)
     .     + wind_x(t)

           mxstar(i,j) = momxstar(i,j)
     .     -g*htt(i,j)*dzetadxstar(i,j)
     .     - qxqxdx(i,j) -qxqydy(i,j)
     .     + dispx(i,j)*factor
c     .     + (qwxqwxdx(i,j))*factor
     .     + (qwxqwxdx(i,j) +qwxqwydy(i,j))*factor

           momystar(i,j) = 0.d0
     .     - force_yx(i,j,t)
     .     - force_yy(i,j,t)
     .     - fricty(i,j)
     .     + dtauxydx(i,j)
     .     + dtauyydy(i,j)
     .     + wind_y(t)

           mystar(i,j) = momystar(i,j)
     .     - g*htt(i,j)*dzetadystar(i,j)
     .     - qyqydy(i,j) -qxqydx(i,j)
     .     + dispy(i,j)*factor
c     .     + (qwyqwydy(i,j))*factor
     .     + (qwxqwydx(i,j)+qwyqwydy(i,j))*factor

        end do
      end do


         do j=1,ny
           do i=nxa(j)+1,nx
             cstar(i,j)=0.d0
             momxstar(i,j)=0.d0
             mxstar(i,j)=0.d0
             momystar(i,j)=0.d0
             mystar(i,j)=0.d0
             cn(i,j)=0.d0
             mxn(i,j)=0.d0
             myn(i,j)=0.d0
           end do
         end do

     

c ## Characteristix on x = 0  -----------------------------------------


      if ((ibc1.eq.2).or.(ibc1.eq.3)) then
        do j=1,ny
          betanp1(2,j) = (ux(qxnp1(2,j),zetanp1(2,j),ht(2,j)) - 2.d0*
     .                cel(zetanp1(2,j),ht(2,j)))
          betanp1(3,j) = (ux(qxnp1(3,j),zetanp1(3,j),ht(3,j)) - 2.d0*
     .                cel(zetanp1(3,j),ht(3,j)))
        end do
        call betachar(bstar,betanp1,zetanp1,qxnp1,qynp1,
     .              dqydystar,dzetadystar,momxstar)
      end if


c----------------------------------------------------------------------
c ## The Corrector Step
c----------------------------------------------------------------------
         do j = 1,ny
            do i = 1,nx

              zetaup = coeff2(1)*cstar(i,j) + coeff2(2)*cn(i,j) +
     .                coeff2(3)*cnm1(i,j) + coeff2(4)*cnm2(i,j)
              qxup = coeff2(1)*mxstar(i,j) + coeff2(2)*mxn(i,j) +
     .               coeff2(3)*mxnm1(i,j) + coeff2(4)*mxnm2(i,j)
              qyup = coeff2(1)*mystar(i,j) + coeff2(2)*myn(i,j) +
     .               coeff2(3)*mynm1(i,j) + coeff2(4)*mynm2(i,j)

              zetanp1(i,j) = zetan(i,j) + zetaup*inv_denom2
              qxnp1(i,j)   = qxn(i,j) + qxup*inv_denom2
              qynp1(i,j)   = qyn(i,j) + qyup*inv_denom2

              end do
         end do


c ##   Check for negative water depths 
       do j = 1,ny
         do i = nxa(j)+1,nx
            qxnp1(i,j)=0.d0
            qynp1(i,j)=0.d0
            zetanp1(i,j)=-ht(i,j)+0.0001d0
            cn(i,j)=0.d0
            mxn(i,j)=0.d0
            myn(i,j)=0.d0
          end do
       end do

c----------------------------------------------------------------------
c ## Flux Conditions (again)

 
      if ((ibc1.eq.2)) then
         do j = 1,ny
              qxnp1(1,j) = 0.d0
         end do
      end if

      if (ibc1.eq.4) then
         do j=1,ny
              qxnp1(1,j) = 0.d0          
         end do
      end if


      if (ibc2.eq.4) then
         do j = 1,ny
             qxnp1(nxa(j),j) = 0.d0      
         end do
      end if

      if (ibc2.eq.6) then
         do j = 1,ny
             qxnp1(nxa(j),j) = 0.d0      
             qynp1(nxa(j),j) = 0.d0    
         end do
      end if

      if (ibc3.eq.1) then
         do i=1,nx
              qynp1(i,1) = qyb3(i)*factor
         end do
      end if

      if (ibc4.eq.1) then
         do i=1,nx
              qynp1(i,ny) = qyb4(i)*factor
         end do
      end if

      if (ibc3.eq.4) then
         do i=1,nx
              qynp1(i,1) = 0.d0
         end do
      end if

      if (ibc4.eq.4) then
         do i=1,nx
              qynp1(i,ny) = 0.d0
         end do
      end if

      if (ibc3.eq.5.and.ibc4.eq.5) then
         do i=1,nx
              qynp1(i,1) = qynp1(i,ny)
              qxnp1(i,1) = qxnp1(i,ny)
              zetanp1(i,1) = zetanp1(i,ny)
         end do
      end if
c----------------------------------------------------------------------
c ## Absorb/generating cond. at the boundary x=0


      if ((ibc1.eq.2).or.(ibc1.eq.3)) then

        do j=1,ny
      
          bnup = coeff2(1)*bstar(j)+ coeff2(2)*bn(j) + 
     .          coeff2(3)*bnm1(j) + coeff2(4)*bnm2(j)
          betanp1(1,j) = betan(1,j)+ bnup*inv_denom2
          alpha2(j)=-alpha(1)
c!!! "aqy" is the incoming y-volume flux and Qi=aqy !!
c          vert = (qynp1(1,j)-aqy(x(1),y(j),t+dt,1))
c          Qi = ampli*dsin(k(1)*dcos(alpha(1))*x(1) 
c     .         + k(1)*dsin(alpha(1))*y(j) - sigma*(t+dt))
c!!! For the case of no incoming waves I simplify "vert, Qi" as:
          vert = qynp1(1,j)
          Qi = 0.d0

          aux1 = Qi**2*(.75d0-dcos(alpha(1))) + Qi*DSQRT(g*ht(1,j))*
     . 		ht(1,j)*(dcos(alpha(1))-1.d0)

          do jj=1,50
c---------- Higher order bound. cond. ---
c      	    qxr = dcos(alpha2(j))*(DSQRT(g*ht(1,j))*ht(1,j)
c     .  	*(dcos(alpha2(j))+1.d0)+Qi*(dcos(alpha(1))
c     .		-dcos(alpha2(j))-1.5d0))/(2.d0*dcos(alpha2(j))+1.5d0)
c     .  	*(-1.d0+DSQRT(1.d0-( (4.d0*dcos(alpha2(j))+3.0d0)
c     .  	*(aux1 - (DSQRT(g*ht(1,j))*ht(1,j))**2
c     .  	*(betanp1(1,j)/DSQRT(g*ht(1,j))+2.d0))
c     .  	/(DSQRT(g*ht(1,j))*ht(1,j)*(dcos(alpha2(j))+1.d0)+Qi
c     .  	*(dcos(alpha(1))-dcos(alpha2(j))-1.5d0))**2)))
c---------- Lower order bound. cond. ---
      	    qxr = dcos(alpha2(j))/(dcos(alpha2(j))+1.d0)
     .   	*(ht(1,j)*(betanp1(1,j)+2.d0*DSQRT(g*ht(1,j)))
     .          -Qi*(dcos(alpha(1))-1.d0))

            if (vert.eq.0.d0 .and. qxr.eq.0.d0) then
               alphanew = 0.d0
            else
               alphanew = datan2(vert,qxr)
            end if
            if(alphanew .gt. (pi*0.5d0)) alphanew=alphanew-pi
            if(alphanew .le. (-pi*0.5d0)) alphanew=alphanew+pi

c---------- Ap's criterion:
c            if (dabs(alphanew-alpha2(j)).le.0.0000001) goto 3000
            if(dabs(alphanew-alpha2(j)).lt.0.001) goto 3000
            alpha2(j) = alphanew

          end do
 3000     continue
      
          qxnp1(1,j) = Qi*dcos(alpha(1)) + qxr

        end do

      end if

c----------------------------------------------------------------------
c ## Apply Shapiro (1970) averaging filter every "nfilter" times
c----------------------------------------------------------------------

c--- filter the volume fluxes
        if ((mod((itstep-1),nfilter1).eq.0)) then

c ## in the x-direction for every j-point
         do j = 1,ny
            do i = 1,nxa(j)
               aux3(i) = qxnp1(i,j)
               aux4(i) = 0.d0
	       aux5(i) = qynp1(i,j)
               aux6(i) = 0.d0
            end do
            call shapd1(aux3,aux4,nxa(j),nxorder,iqxfilter)
            call shapd1(aux5,aux6,nxa(j),nxorder,iqxfilter)
            do i = 1,nxa(j)
               qxnp1(i,j)= qxnp1(i,j) - aux4(i)
               qynp1(i,j)= qynp1(i,j) - aux6(i)
            end do
         end do


c ## in the y-direction for every i-point
         do i = 1,nx
            do j = 1,ny
               aux3(j) = qxnp1(i,j)
               aux4(j) = 0.d0
	       aux5(j) = qynp1(i,j)
               aux6(j) = 0.d0
            end do
	    if(iqyfilter.eq.5) then
               aux3(ny+1) = qxnp1(i,2)
               aux4(ny+1) = 0.d0
               aux5(ny+1) = qynp1(i,2)
               aux6(ny+1) = 0.d0
               call shapd1(aux3,aux4,ny+1,nyorder,iqyfilter)
               call shapd1(aux5,aux6,ny+1,nyorder,iqyfilter)
	    else
               call shapd1(aux3,aux4,ny,nyorder,iqyfilter)
               call shapd1(aux5,aux6,ny,nyorder,iqyfilter)
	    endif
            do j = 1,ny
               qxnp1(i,j)= qxnp1(i,j) - aux4(j)
               qynp1(i,j)= qynp1(i,j) - aux6(j)
            end do
         end do
         end if


c--- filter the surface elevation
        if ((mod((itstep-1),nfilter2).eq.0)) then
c ## in the x-direction for every j-point
         do j = 1,ny
            do i = 1,nxa(j)
               aux(i) = zetanp1(i,j)
               aux2(i) = 0.d0
            end do
            call shapd1(aux, aux2,nxa(j),nxorder,izxfilter)
            do i = 1,nxa(j)
               zetanp1(i,j)= zetanp1(i,j) - aux2(i)
            end do
         end do
c ## in the y-direction for every i-point
         do i = 1,nx
            do j = 1,ny
               aux(j) = zetanp1(i,j)
               aux2(j) = 0.d0
            end do
	    if(izyfilter.eq.5) then
               aux(ny+1) = zetanp1(i,2)
               aux2(ny+1) = 0.d0
               call shapd1(aux, aux2,ny+1,nyorder,izyfilter)
	    else
               call shapd1(aux, aux2,ny,nyorder,izyfilter)
	    endif
            do j = 1,ny
               zetanp1(i,j)= zetanp1(i,j) - aux2(j)
            end do
         end do
778      continue
         end if
779      continue
	
c ##  Reset zetanp1, qxnp1, qynp1 in the "dry" region ----------------
       do j = 1,ny
         do i = nxa(j)+1,nx
            qxnp1(i,j)=0.d0
            qynp1(i,j)=0.d0
            zetanp1(i,j)=-ht(i,j)+0.0001d0
         end do
       end do


c----------------------------------------------------------------------
c ## Calculate time-averages of all the terms in the governing eqs.
c----------------------------------------------------------------------
      if (time_master.ge.5.d0/delay) then
c      if (t.ge.5.d0/delay) then
        average = average + 1.d0
        do j = 1,ny
          do i=1,nx
            htt(i,j) = ht(i,j)+zetanp1(i,j)
            adqxdx(i,j) = dqxdxstar(i,j) + adqxdx(i,j)
            adqydy(i,j) = dqydystar(i,j) + adqydy(i,j)
            africtx(i,j) = frictx(i,j) + africtx(i,j)
            adtaudy(i,j) = dtauxydy(i,j) + adtaudy(i,j)
            adzdx(i,j) = g*htt(i,j)*dzetadxstar(i,j)
     .                   + adzdx(i,j)
            aqxqxdx(i,j) = qxqxdx(i,j) + aqxqxdx(i,j) 
            aqxqydy(i,j) = qxqydy(i,j) + aqxqydy(i,j)
            adispx(i,j) = dispx(i,j) + adispx(i,j)

            africty(i,j) = fricty(i,j) + africty(i,j)
            adtaudx(i,j) = dtauxydx(i,j) + adtaudx(i,j)
            adzdy(i,j) = g*htt(i,j)*dzetadystar(i,j)
     .                   + adzdy(i,j)
            aqyqydy(i,j) = qyqydy(i,j) + aqyqydy(i,j) 
            aqxqydx(i,j) = qxqydx(i,j) + aqxqydx(i,j)
            adispy(i,j) = dispy(i,j) + adispy(i,j)

            azeta(i,j) = zetan(i,j) + azeta(i,j)
            aqxn(i,j) = qxn(i,j) + aqxn(i,j) 
            aqyn(i,j) = qyn(i,j) + aqyn(i,j) 
          end do
        end do
      end if

c----------------------------------------------------------------------
c ## Write values for zeta and q at various locations at the current
c ## time level 
c----------------------------------------------------------------------

c        if ((mod((itstep-1),jump).eq.0)) then  
      if (mod((ts-1),jump).eq.0) then
           do i=1,nsensor
             if (xsensor(i).ne.0 .and. ysensor(i).ne.0) then
               write(i+50,996) zetan(xsensor(i),ysensor(i)),
     .	        qxn(xsensor(i),ysensor(i)), qyn(xsensor(i),ysensor(i))
             endif
           end do
       end if    

c     write the files for continuing with a hot start

c        if (itstep.eq.(ntime-2)) then
c           open(unit=30,file='hot2.dat',access='direct',recl=4*ny)
c           do i=1,nx
c             write(30,rec=i) (sngl(zetan(i,j)),j=1,ny)
c             write(30,rec=i+nx) (sngl(qxn(i,j)),j=1,ny)
c             write(30,rec=i+2*nx) (sngl(qyn(i,j)),j=1,ny)
c           end do
c        end if

c        if (itstep.eq.(ntime-1)) then
c           open(unit=30,file='hot1.dat',access='direct',recl=4*ny)
c           do i=1,nx
c             write(30,rec=i) (sngl(zetan(i,j)),j=1,ny)
c             write(30,rec=i+nx) (sngl(qxn(i,j)),j=1,ny)
c             write(30,rec=i+2*nx) (sngl(qyn(i,j)),j=1,ny)
c           end do
c        end if

c        if (itstep.eq.(ntime)) then
c           open(unit=30,file='hot0.dat',access='direct',recl=4*ny)
c           do i=1,nx
c             write(30,rec=i) (sngl(zetan(i,j)),j=1,ny)
c             write(30,rec=i+nx) (sngl(qxn(i,j)),j=1,ny)
c             write(30,rec=i+2*nx) (sngl(qyn(i,j)),j=1,ny)
c           end do
c        end if

c ## write only at specified time-steps ------------------------

c         if ((mod((itstep-1),interval).eq.0)) then
      if (mod(ts-1,interval*ntime).eq.0) then

c ## write Zeta, qx, qy
c           kounter=(itstep-1)/interval
c           write(6,*) itstep,t,kounter+100
c           write(unit=name1,fmt=244)100+kounter
c           open(unit=30,file='fort.'//name1,access='direct',recl=4*ny)
c           do i=1,nx
c             write(30,rec=i) (sngl(zetan(i,j)),j=1,ny)
c             write(30,rec=i+nx) (sngl(qxn(i,j)),j=1,ny)
c             write(30,rec=i+2*nx) (sngl(qyn(i,j)),j=1,ny)
c           end do
c	   close(30)
244       format(I3)   


           write(6,*)'writing output   ', 
     .          ts,kounter+100
           write(unit=name1,fmt=244)100+kounter
           open(unit=30,file='fort.'//name1,access='direct',recl=4*ny)
           do i=1,nx
             write(30,rec=i) (sngl(zetan(i,j)),j=1,ny)
             write(30,rec=i+nx) (sngl(qxn(i,j)),j=1,ny)
             write(30,rec=i+2*nx) (sngl(qyn(i,j)),j=1,ny)
              write(30,rec=i+3*nx) (sngl(ht(i,j)),j=1,ny)
              write(30,rec=i+4*nx) (sngl(qwx(i,j)),j=1,ny)
              write(30,rec=i+5*nx) (sngl(qwy(i,j)),j=1,ny)
          end do
	   close(30)
           write(unit=name1,fmt=244)800+kounter
           open(unit=30,file='fort.'//name1,access='direct',recl=4*ny)
           do i=1,nx
             write(30,rec=i)(sngl(H(i,j)),j=1,ny)
             write(30,rec=i+nx)(sngl(theta(i,j)/pi*180.d0),j=1,ny)
           end do
	   close(30)
           kounter=kounter+1



c ## write variables for velocity depth profiles ---------------------
      if (yprofile(1).ne.0) then
          open (unit=21,file='fort.401',status='unknown')
      j=yprofile(1)
         write(21,820) j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j
     .     ,j,j,j,j,j,j,j,j,j,j,j,j
      do i=1,nx
       write(21,994) d1x(i,j),e1x(i,j),fs1x(i,j),f2x(i,j), 
     .               d1y(i,j),e1y(i,j),fs1y(i,j),f2y(i,j), 
     .               ht(i,j),zetanp1(i,j),qxnp1(i,j),qynp1(i,j)
     .               ,uda4(i,j),uda3(i,j),uda2(i,j),
     .               vda4(i,j),vda3(i,j),vda2(i,j),
     .               udb4(i,j),udb3(i,j),udb2(i,j),
     .               vdb4(i,j),vdb3(i,j),vdb2(i,j),
     .               udw4(i,j),udw3(i,j),udw2(i,j),
     .               vdw4(i,j),vdw3(i,j),vdw2(i,j),
     .               udc(i,j),vdc(i,j),qwx(i,j),qwy(i,j)
      end do
	   close(21) 
      end if
      if (yprofile(2).ne.0) then
           open (unit=22,file='fort.402',status='unknown')
	j=yprofile(2)
         write(22,820) j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j
     .     ,j,j,j,j,j,j,j,j,j,j,j,j
      do i=1,nx
       write(22,994) d1x(i,j), e1x(i,j), fs1x(i,j),f2x(i,j), 
     .               d1y(i,j), e1y(i,j), fs1y(i,j),f2y(i,j), 
     .                 ht(i,j), zetanp1(i,j), qxnp1(i,j),
     .                  qynp1(i,j)
     .               ,uda4(i,j),uda3(i,j),uda2(i,j),
     .               vda4(i,j),vda3(i,j),vda2(i,j),
     .               udb4(i,j),udb3(i,j),udb2(i,j),
     .               vdb4(i,j),vdb3(i,j),vdb2(i,j),
     .               udw4(i,j),udw3(i,j),udw2(i,j),
     .               vdw4(i,j),vdw3(i,j),vdw2(i,j),
     .               udc(i,j),vdc(i,j),qwx(i,j),qwy(i,j)
      end do
	   close(22) 
      end if
      if (yprofile(3).ne.0) then
          open (unit=23,file='fort.403',status='unknown')
	j=yprofile(3)
         write(23,820) j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j
     .     ,j,j,j,j,j,j,j,j,j,j,j,j
      do i=1,nx
       write(23,994) d1x(i,j), e1x(i,j), fs1x(i,j),f2x(i,j), 
     .               d1y(i,j), e1y(i,j), fs1y(i,j),f2y(i,j), 
     .                 ht(i,j), zetanp1(i,j), qxnp1(i,j),
     .                  qynp1(i,j) 
     .               ,uda4(i,j),uda3(i,j),uda2(i,j),
     .               vda4(i,j),vda3(i,j),vda2(i,j),
     .               udb4(i,j),udb3(i,j),udb2(i,j),
     .               vdb4(i,j),vdb3(i,j),vdb2(i,j),
     .               udw4(i,j),udw3(i,j),udw2(i,j),
     .               vdw4(i,j),vdw3(i,j),vdw2(i,j),
     .               udc(i,j),vdc(i,j),qwx(i,j),qwy(i,j)
      end do
	   close(23) 
      end if
      if (yprofile(4).ne.0) then
          open (unit=24,file='fort.404',status='unknown')
      j=yprofile(4)
         write(24,820) j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j
     .     ,j,j,j,j,j,j,j,j,j,j,j,j
      do i=1,nx
       write(24,994) d1x(i,j), e1x(i,j), fs1x(i,j),f2x(i,j), 
     .               d1y(i,j), e1y(i,j), fs1y(i,j),f2y(i,j), 
     .                 ht(i,j), zetanp1(i,j), qxnp1(i,j),
     .                  qynp1(i,j) 
     .               ,uda4(i,j),uda3(i,j),uda2(i,j),
     .               vda4(i,j),vda3(i,j),vda2(i,j),
     .               udb4(i,j),udb3(i,j),udb2(i,j),
     .               vdb4(i,j),vdb3(i,j),vdb2(i,j),
     .               udw4(i,j),udw3(i,j),udw2(i,j),
     .               vdw4(i,j),vdw3(i,j),vdw2(i,j),
     .               udc(i,j),vdc(i,j),qwx(i,j),qwy(i,j)
      end do
	   close(24) 
       end if
      if (yprofile(5).ne.0) then
         open (unit=25,file='fort.405',status='unknown')
      j=yprofile(5)
         write(25,820) j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j
     .     ,j,j,j,j,j,j,j,j,j,j,j,j
      do i=1,nx
       write(25,994) d1x(i,j), e1x(i,j), fs1x(i,j),f2x(i,j), 
     .               d1y(i,j), e1y(i,j), fs1y(i,j),f2y(i,j), 
     .                 ht(i,j), zetanp1(i,j), qxnp1(i,j),
     .                  qynp1(i,j) 
     .               ,uda4(i,j),uda3(i,j),uda2(i,j),
     .               vda4(i,j),vda3(i,j),vda2(i,j),
     .               udb4(i,j),udb3(i,j),udb2(i,j),
     .               vdb4(i,j),vdb3(i,j),vdb2(i,j),
     .               udw4(i,j),udw3(i,j),udw2(i,j),
     .               vdw4(i,j),vdw3(i,j),vdw2(i,j),
     .               udc(i,j),vdc(i,j),qwx(i,j),qwy(i,j)
      end do
	   close(25) 
      end if
      if (yprofile(6).ne.0) then
          open (unit=26,file='fort.406',status='unknown')
      j=yprofile(6)
         write(26,820) j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j
     .     ,j,j,j,j,j,j,j,j,j,j,j,j
      do i=1,nx
       write(26,994) d1x(i,j), e1x(i,j), fs1x(i,j),f2x(i,j), 
     .               d1y(i,j), e1y(i,j), fs1y(i,j),f2y(i,j), 
     .                 ht(i,j), zetanp1(i,j), qxnp1(i,j),
     .                  qynp1(i,j) 
     .               ,uda4(i,j),uda3(i,j),uda2(i,j),
     .               vda4(i,j),vda3(i,j),vda2(i,j),
     .               udb4(i,j),udb3(i,j),udb2(i,j),
     .               vdb4(i,j),vdb3(i,j),vdb2(i,j),
     .               udw4(i,j),udw3(i,j),udw2(i,j),
     .               vdw4(i,j),vdw3(i,j),vdw2(i,j),
     .               udc(i,j),vdc(i,j),qwx(i,j),qwy(i,j)
      end do
	   close(26) 
      end if
      if (yprofile(7).ne.0) then

          open (unit=27,file='fort.407',status='unknown')
      j=yprofile(7)
         write(27,820) j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j
     .     ,j,j,j,j,j,j,j,j,j,j,j,j
      do i=1,nx
       write(27,994) d1x(i,j), e1x(i,j), fs1x(i,j),f2x(i,j), 
     .               d1y(i,j), e1y(i,j), fs1y(i,j),f2y(i,j), 
     .                 ht(i,j), zetanp1(i,j), qxnp1(i,j),
     .                  qynp1(i,j) 
     .               ,uda4(i,j),uda3(i,j),uda2(i,j),
     .               vda4(i,j),vda3(i,j),vda2(i,j),
     .               udb4(i,j),udb3(i,j),udb2(i,j),
     .               vdb4(i,j),vdb3(i,j),vdb2(i,j),
     .               udw4(i,j),udw3(i,j),udw2(i,j),
     .               vdw4(i,j),vdw3(i,j),vdw2(i,j),
     .               udc(i,j),vdc(i,j),qwx(i,j),qwy(i,j)
      end do
	   close(27) 
      end if
      if (yprofile(8).ne.0) then
          open (unit=28,file='fort.408',status='unknown')
      j=yprofile(8)
         write(28,820) j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j,j
     .     ,j,j,j,j,j,j,j,j,j,j,j,j
      do i=1,nx
       write(28,994) d1x(i,j), e1x(i,j), fs1x(i,j),f2x(i,j), 
     .               d1y(i,j), e1y(i,j), fs1y(i,j),f2y(i,j), 
     .                 ht(i,j), zetanp1(i,j), qxnp1(i,j),
     .                  qynp1(i,j) 
     .               ,uda4(i,j),uda3(i,j),uda2(i,j),
     .               vda4(i,j),vda3(i,j),vda2(i,j),
     .               udb4(i,j),udb3(i,j),udb2(i,j),
     .               vdb4(i,j),vdb3(i,j),vdb2(i,j),
     .               udw4(i,j),udw3(i,j),udw2(i,j),
     .               vdw4(i,j),vdw3(i,j),vdw2(i,j),
     .               udc(i,j),vdc(i,j),qwx(i,j),qwy(i,j)
      end do
	   close(28) 
      end if
c ## write last wet point file
           open (unit=21,file='fort.701',status='unknown')
           write(21,*) (nxa(j),j=1,ny)
	   close(21)



       if (momout.eq.1) then
c ## write forces in momentum eqs -----------------------------
           do iunit=21,42
              write(unit=name2(iunit),fmt=244)580+iunit
             open(iunit,file='fort.'//name2(iunit),access='direct',
     .      recl=4*ny)
           end do
           open(iunit,file='fort.331',access='direct',recl=4*ny)
           do i=1,nx
c ## x-mom eq. terms
	     write(21,rec=i) (sngl(-force_xx(i,j,t)),j=1,ny)
	     write(22,rec=i) (sngl(-force_xy(i,j,t)),j=1,ny)
	     write(23,rec=i) (sngl(-frictx(i,j)),j=1,ny)
	     write(24,rec=i) (sngl(dtauxydy(i,j)),j=1,ny)
	     write(25,rec=i) (sngl(-g*htt(i,j)
     .		*dzetadxstar(i,j)),j=1,ny)
	     write(26,rec=i) (sngl(-qxqxdx(i,j)-qxqydy(i,j)),j=1,ny)
	     write(33,rec=i) (sngl(dispx(i,j)*factor),j=1,ny)
	     write(35,rec=i) (sngl(-(qxnp1(i,j)-qxn(i,j))/dt),j=1,ny)
	     write(37,rec=i) (sngl(qxqxdx(i,j)),j=1,ny)
	     write(38,rec=i) (sngl(qxqydy(i,j)),j=1,ny)
c ## y-mom eq. terms
	     write(27,rec=i) (sngl(-force_yx(i,j,t)),j=1,ny)
	     write(28,rec=i) (sngl(-force_yy(i,j,t)),j=1,ny)
	     write(29,rec=i) (sngl(-fricty(i,j)),j=1,ny)
	     write(30,rec=i) (sngl(dtauxydx(i,j)),j=1,ny)
	     write(31,rec=i) (sngl(-g*htt(i,j)
     .		*dzetadystar(i,j)),j=1,ny)
	     write(32,rec=i) (sngl(-qyqydy(i,j)-qxqydx(i,j)),j=1,ny)
	     write(34,rec=i) (sngl(dispy(i,j)*factor),j=1,ny)
	     write(36,rec=i) (sngl(-(qynp1(i,j)-qyn(i,j))/dt),j=1,ny)
	     write(39,rec=i) (sngl(qyqydy(i,j)),j=1,ny)
	     write(40,rec=i) (sngl(qxqydx(i,j)),j=1,ny)
c ## other terms
	     write(41,rec=i) (sngl(wind_x(t)),j=1,ny)
	     write(42,rec=i) (sngl(wind_y(t)),j=1,ny)
c ## Smagorinsky Eddy Viscosity
             write(43,rec=i) (sngl(vs(i,j)),j=1,ny)
           end do
           do iunit=21,43
             close(iunit)
           end do
         end if

 

c<========================qun Sep.9,1999===================>
c write quasi-3d ciefficients at steady state
      if (disp3d.eq.1.and.dispout.eq.1) then
      do iunit=36,40
       write(unit=name3(iunit),fmt=244)710+iunit
       open(iunit,file='fort.'//name3(iunit),access='direct',
     .   recl=4*ny)
      end do

      do i=1,nx
      write(36,rec=i) (sngl(Bxx(i,j)),j=1,ny)
      write(36,rec=i+nx) (sngl(Bxy(i,j)),j=1,ny)
      write(36,rec=i+2*nx) (sngl(Byy(i,j)),j=1,ny)
      write(37,rec=i) (sngl(Dxx(i,j)),j=1,ny)
      write(37,rec=i+nx) (sngl(Dxy(i,j)),j=1,ny)
      write(37,rec=i+2*nx) (sngl(Dyy(i,j)),j=1,ny)
      write(38,rec=i) (sngl(Mxx(i,j)),j=1,ny)
      write(38,rec=i+nx) (sngl(Mxy(i,j)),j=1,ny)
      write(38,rec=i+2*nx) (sngl(Myy(i,j)),j=1,ny)
      write(39,rec=i) (sngl(Axxx(i,j)),j=1,ny)
      write(39,rec=i+nx) (sngl(Axyx(i,j)),j=1,ny)
      write(39,rec=i+2*nx) (sngl(Ayyx(i,j)),j=1,ny)
      write(40,rec=i) (sngl(Axxy(i,j)),j=1,ny)
      write(40,rec=i+nx) (sngl(Axyy(i,j)),j=1,ny)
      write(40,rec=i+2*nx) (sngl(Ayyy(i,j)),j=1,ny)
      end do

      do iunit=36,40
      close(iunit)
      end do
      end if
c<========================qun Sep.9,1999===================>


         end if

c----------------------------------------------------------------------
c ## Update values: roll time levels, calculate MASS and ENERGY
c----------------------------------------------------------------------



	 mass = 0.d0
	 energy = 0.d0
	 qxtotal = 0.d0
	 qytotal = 0.d0

c
c	calculate mass based on the trapezoidal rule
c
	mass=.25d0*(zetan(1,1)+zetan(1,ny)+zetan(nx,1)+zetan(nx,ny)
     . 		+ht(1,1)+ht(1,ny)+ht(nx,1)+ht(nx,ny))
	do j=2,ny-1
	  mass=mass+(zetan(1,j)+zetan(nx,j)+ht(1,j)+ht(nx,j))*.5d0
	  do i=2,nx-1
	    mass =mass+zetan(i,j)+ht(i,j)
	  end do
	end do

	do i=2,nx-1
	  mass=mass+(zetan(i,1)+zetan(i,ny)+ht(i,1)+ht(i,ny))*.5d0
	end do
	mass=mass*dx*dy

2        do i = 1,nx
            do j = 1,ny

c             ## Final values, next time level

               zetan(i,j)   = zetanp1(i,j)
               qxn(i,j)     = qxnp1(i,j)
               qyn(i,j)     = qynp1(i,j)

c             ## Move RHS up one time level

               cnm2(i,j)  = cnm1(i,j)
               mxnm2(i,j) = mxnm1(i,j)
               mynm2(i,j) = mynm1(i,j)
 
               cnm1(i,j)  = cn(i,j)
               mxnm1(i,j) = mxn(i,j)
               mynm1(i,j) = myn(i,j)

	       energy = 0.5d0*( zetan(i,j)*zetan(i,j)-ht(i,j)*ht(i,j)
     .		+(qxn(i,j)*qxn(i,j)+qyn(i,j)*qyn(i,j))
     .		/(g*(ht(i,j)+zetan(i,j))) ) + energy

            end do
	    qxtotal = qxn(i,1) + qxn(i,ny) + qxtotal
	    qytotal = qyn(i,1) + qyn(i,ny) + qytotal
         end do
c!!! write MASS and ENERGY into file fort.50
c!!! xfluxin is the total mass flux through the boundary i=1
	 xfluxin = 0.d0
	 yfluxin = 0.d0
	 do j=1,ny
	   xfluxin = qxn(1,j)+xfluxin
	   yfluxin = qyn(1,j)+yfluxin
	 end do

c        if ((mod((itstep-1),jump).eq.0))
c     .	 write(50,911) mass/mass0, energy/energy0, xfluxin,
c     .   yfluxin, qxtotal, qytotal


         if ((ibc1.eq.2).or.(ibc1.eq.3)) then
           do j=1,ny
             betan(1,j)=betanp1(1,j)
             do i=2,3              
               betan(i,j) = (ux(qxnp1(i,j),zetanp1(i,j),ht(i,j))
     .                   - 2.d0*cel(zetanp1(i,j),ht(i,j)))
             end do
             bnm2(j) = bnm1(j)
             bnm1(j) = bn(j)
           end do
         end if

         t = t+dt
 
      end do
c----------------------------------------------------------------------
c ## END TIME LOOP !!!   
c----------------------------------------------------------------------  
c     create bathymetry and currents for master program 4/30/03 KAH
	do j=1,ny
   	  do i=1,nx
	    Pass_eta(i,j)=sngl(zetan(i,j))
	    Pass_U(i,j)=sngl((qxn(i,j)-qwx(i,j))/(ht(i,j)+zetan(i,j)))
	    Pass_V(i,j)=sngl((qyn(i,j)-qwy(i,j))/(ht(i,j)+zetan(i,j)))
	    Pass_Ub(i,j)=sngl((qxn(i,j)-qwx(i,j))/(ht(i,j)+zetan(i,j)))
     .           +fs1x(i,j)+f2x(i,j)+udc(i,j)
	    Pass_Vb(i,j)=sngl((qyn(i,j)-qwy(i,j))/(ht(i,j)+zetan(i,j)))
     .           +fs1y(i,j)+f2y(i,j)+vdc(i,j)

c	    cu(i,j)=sngl((qxn(i,j))/(ht(i,j)+zetan(i,j)))
c	    cv(i,j)=sngl((qyn(i,j))/(ht(i,j)+zetan(i,j)))
c            cu(i,j)=0
c            cv(i,j)=0
c            ceta(i,j)=0
	  end do
	    Pass_U(nx,j)=0.d0
c	    cv(nx,j)=0.d0
   	end do

	print*,'u,v',pass_u(10,10),pass_v(10,10)

c        write(*,*)(ceta(i,1),i=1,nx)
c        write(*,*)(cu(i,1),i=1,nx)
c        write(*,*)(cv(i,1),i=1,nx)
c        write(*,*)'cet,cnt,cdt',cet,cnt,cdt

        if ((time_master-Total_Time).ge.-10e-4) then
          
        do i=1,nsensor
        if (xsensor(i).ne.0 .and. ysensor(i).ne.0) then
	  close(i+40)
	end if
        end do

c ## write time-averages files ---------------------------------------
      if (time_master.ge.5.d0/delay.and.tavgout.eq.1) then
      do iunit=11,35
       write(unit=name3(iunit),fmt=244)490+iunit
       open(iunit,file='fort.'//name3(iunit),access='direct',
     .   recl=4*ny)
      end do
      inv_average = 1.d0/average
      do i=1,nx
	 write(11,rec=i) (sngl(adqxdx(i,j)*inv_average),j=1,ny)
	 write(12,rec=i) (sngl(adqydy(i,j)*inv_average),j=1,ny)
c ------ x-mom eq. terms
	 write(13,rec=i) (sngl(africtx(i,j)*inv_average),j=1,ny)
	 write(14,rec=i) (sngl(adtaudy(i,j)*inv_average),j=1,ny)
	 write(15,rec=i) (sngl(adzdx(i,j)*inv_average),j=1,ny)
	 write(16,rec=i) (sngl(aqxqxdx(i,j)*inv_average),j=1,ny)
	 write(17,rec=i) (sngl(aqxqydy(i,j)*inv_average),j=1,ny)
	 write(18,rec=i) (sngl(adispx(i,j)*inv_average),j=1,ny)
c ------ y-mom eq. terms
	 write(19,rec=i) (sngl(africty(i,j)*inv_average),j=1,ny)
	 write(20,rec=i) (sngl(adtaudx(i,j)*inv_average),j=1,ny)
	 write(21,rec=i) (sngl(adzdy(i,j)*inv_average),j=1,ny)
	 write(22,rec=i) (sngl(aqyqydy(i,j)*inv_average),j=1,ny)
	 write(23,rec=i) (sngl(aqxqydx(i,j)*inv_average),j=1,ny)
	 write(24,rec=i) (sngl(adispy(i,j)*inv_average),j=1,ny)
      end do
c ------variables
      do j=1,ny
        do i=1,nx
          azeta(i,j) = azeta(i,j)*inv_average
          aqxn(i,j) = aqxn(i,j)*inv_average
          aqyn(i,j) = aqyn(i,j)*inv_average
          htot = ht(i,j) + azeta(i,j)
          qxqx(i,j) = aqxn(i,j)*aqxn(i,j)/htot
          qxqy(i,j) = aqxn(i,j)*aqyn(i,j)/htot
          qyqy(i,j) = aqyn(i,j)*aqyn(i,j)/htot
          Uo(i,j) = ux(aqxn(i,j),ht(i,j),azeta(i,j))
          Vo(i,j) = uy(aqyn(i,j),ht(i,j),azeta(i,j))
        end do
      end do
      ncode =1
      nxflag=1
      call deriv(qxqy,qxqx,qyqy,qxqydx,qxqydy,qxqxdx,qyqydy,
     .		 ncode,nxflag)
      ncode =1
      nxflag=1
      call deriv(azeta,aqxn,aqyn,dzetadxn,dzetadyn,dqxdxn,dqydyn,
     .           ncode,nxflag)

      call bottom_friction(azeta,Uo,Vo,frictx,fricty,
     .			   factor,itstep)

      do i=1,nx
	 write(25,rec=i) (sngl(azeta(i,j)),j=1,ny)
	 write(26,rec=i) (sngl(aqxn(i,j)),j=1,ny)
	 write(27,rec=i) (sngl(aqyn(i,j)),j=1,ny)
	 write(28,rec=i) (sngl(qxqydx(i,j)),j=1,ny)
	 write(29,rec=i) (sngl(qxqydy(i,j)),j=1,ny)
	 write(30,rec=i) (sngl(qxqxdx(i,j)),j=1,ny)
	 write(31,rec=i) (sngl(qyqydy(i,j)),j=1,ny)
	 write(32,rec=i) (sngl(g*(ht(i,j)+azeta(i,j))
     .            *dzetadxn(i,j) ),j=1,ny)
	 write(33,rec=i) (sngl(g*(ht(i,j)+azeta(i,j))
     .            *dzetadyn(i,j) ),j=1,ny)
	 write(34,rec=i) (sngl(frictx(i,j)),j=1,ny)
	 write(35,rec=i) (sngl(fricty(i,j)),j=1,ny)
      end do
      do iunit=11,35
         close(iunit)
      end do

      end if

        end if



820   format(34I4)
901   format(/A,$)
902   format(6I8)
903   format(/A,3I5)
905   format(500(f10.4))
907   format( 2x, 3(I15,2x))
911   format( 1x, 6(f16.8,1x))
994   format( 1x, 34(f13.8,1x))
995   format(500(I3))
996   format( 2x, 10(f15.10,2x))
997   format( 2x, f15.10)
998   format( 2x, f15.6)
999   format( 2x, 5(f15.10,1x))

      return
      end

c #####################################################################


