clear

nx = 76;
ny = 100;

dx = 3;
dy = 10;

umean = zeros(nx,ny);
vmean = umean;

counter = 0;
for ll = 80:120

a = ['fid=fopen( ''data/u', num2str(mod(floor(ll/10000),10)),...
      num2str(mod(floor(ll/1000),10)), ...
      num2str(mod(floor(ll/100),10)), num2str(mod(floor(ll/10),10)),...
      num2str(mod(floor(ll/1),10)),'.out'',''r'' ); ' ];
eval(a);
u = fread(fid,[ny,nx],'single');
fclose(fid);

a = ['fid=fopen( ''data/v', num2str(mod(floor(ll/10000),10)),...
      num2str(mod(floor(ll/1000),10)), ...
      num2str(mod(floor(ll/100),10)), num2str(mod(floor(ll/10),10)),...
      num2str(mod(floor(ll/1),10)),'.out'',''r'' ); ' ];
eval(a);
v = fread(fid,[ny,nx],'single');
fclose(fid);

umean = umean + u';
vmean = vmean + v';
counter = counter + 1;

end

umean = umean/counter;
vmean = vmean/counter;

vort = zeros(nx,ny);
vx = vort;
uy =vort;

vx(2:nx-1,:) = (vmean(3:nx,:)-vmean(1:nx-2,:))/(2*dx);
vx(1,:) = (vmean(2,:)-vmean(1,:))/dx;
vx(nx,:) = (vmean(nx,:)-vmean(nx-1,:))/dx;

uy(:,2:ny-1) = (umean(:,3:ny)-umean(:,1:ny-2))/(2*dy);
uy(:,1) = (umean(:,2)-umean(:,1))/dy;
uy(:,ny) = (umean(:,ny)-umean(:,ny-1))/dy;

vort = vx-uy;

u1d = mean(umean,2);
v1d = mean(vmean,2);

x = (0:nx-1)*dx;
y =(0:ny-1)*dy;

figure(1)
plot(x,u1d,'--',x,v1d,'-')
xlabel('x (m)','fontsize',14);
ylabel('U, V (m/s)','fontsize',14);


print -deps vels.eps

figure(2)
xx = (x')*ones(1,ny);
yy = ones(nx,1)*y;

pcolor(xx,yy,vort), shading interp
xlabel('x (m)','fontsize',14);
ylabel('y (m)','fontsize',14);

print -depsc vort.eps






