        implicit none
	
        include 'p1.h'

        complex amp(0:nx1,0:ny1), at(0:nx1,0:ny1), ax(0:nx1,0:ny1),
     &  ayy(0:nx1,0:ny1), axx(0:nx1,0:ny1),
     &  ay(0:nx1,0:ny1), axy(0:nx1,0:ny1)

        complex atold(0:nx1,0:ny1), aold(0:nx1,0:ny1),
     &  ayc(0:nx1,0:ny1), ain2(0:ny1)	 

        real h(0:nx1,0:ny1), cel(0:nx1,0:ny1), cg(0:nx1,0:ny1), 
     &  wnk(0:nx1,0:ny1), dd(0:nx1,0:ny1), cga(0:nx1,0:ny1),
     &  cgb(0:nx1,0:ny1), sigkk(0:nx1,0:ny1), nn(0:nx1,0:ny1),
     &  q(0:nx1,0:ny1), dkdt(0:nx1,0:ny1), dldt(0:nx1,0:ny1),
     &  kapt(0:nx1,0:ny1), uu(0:nx1,0:ny1), vv(0:nx1,0:ny1),
     &  sigma(0:nx1,0:ny1), etat(0:nx1,0:ny1)

        real   sigt(0:nx1,0:ny1), kk(0:nx1,0:ny1), ll(0:nx1,0:ny1),
     &  omk(0:nx1,0:ny1), etac(0:nx1,0:ny1), part1(0:nx1,0:ny1),
     &  part2(0:nx1,0:ny1), ddot12(0:nx1,0:ny1),
     &  wnkold(0:nx1,0:ny1), kaptold(0:nx1,0:ny1)

        real kkold(0:nx1,0:ny1), llold(0:nx1,0:ny1), 
     &  ktold(0:nx1,0:ny1), ltold(0:nx1,0:ny1), w(0:nx1,0:ny1),
     &  brflag1(0:nx1,0:ny1), brflag2(0:nx1,0:ny1),
     &  brfrac(0:nx1,0:ny1), brt(0:nx1,0:ny1), ccgy(0:nx1,0:ny1),
     &  psi(0:nx1,0:ny1), hbar(0:nx1,0:ny1),
     &  kbar(0:nx1,0:ny1), lbar(0:nx1,0:ny1), sigbar(0:nx1,0:ny1)

        real tbr(0:nx1,0:ny1),dtdt(0:nx1,0:ny1)
    
        real ubar(0:nx1,0:ny1), vbar(0:nx1,0:ny1),
     &  kapbar(0:nx1,0:ny1), sfreq(maxfreq), famp(maxfreq),
     &  phase(maxfreq), sang(maxfreq), wll(maxfreq),cwnl
    
        real dudx(0:nx1,0:ny1), dudy(0:nx1,0:ny1),
     &  dvdx(0:nx1,0:ny1), dvdy(0:nx1,0:ny1), etax(0:nx1,0:ny1),
     &  etay(0:nx1,0:ny1), dudt(0:nx1,0:ny1), dvdt(0:nx1,0:ny1),
     &  etaold(0:nx1,0:ny1), etatold(0:nx1,0:ny1), 
     &  uold(0:nx1,0:ny1), utold(0:nx1,0:ny1),
     &  vold(0:nx1,0:ny1), vtold(0:nx1,0:ny1),
     &  dsxxdx(0:nx1,0:ny1), dsxydx(0:nx1,0:ny1),
     &  dsyydy(0:nx1,0:ny1), dsxydy(0:nx1,0:ny1)

	real  wc(0:nx1,0:ny1), edvis(0:nx1,0:ny1),
     &  part1a(0:nx1,0:ny1), part2a(0:nx1,0:ny1), 
     &  part3a(0:nx1,0:ny1), part4a(0:nx1,0:ny1),
     &  part5a(0:nx1,0:ny1), 
     &  etaxx(0:nx1,0:ny1),etayy(0:nx1,0:ny1),
     &  lsw(0:ny1), etsw(0:ny1), svol(0:ny1),svold(0:ny1)

  
        real jm(2,0:ny1), 
     &        phi(2,0:ny1), kaphat(0:nx1,0:ny1) 
    

        real dx, dy, dt, om, per, dx2, dy2, dxsq, dysq,time,
     &       slope

	real f1(0:nx1,0:ny1), f2(0:nx1,0:ny1)


        real at1(0:nx1,0:ny1), at2(0:nx1,0:ny1),
     &      at3(0:nx1,0:ny1), etat1(0:nx1,0:ny1),
     &      etat2(0:nx1,0:ny1), etat3(0:nx1,0:ny1),
     &      ut1(0:nx1,0:ny1), ut2(0:nx1,0:ny1),
     &      ut3(0:nx1,0:ny1), vt1(0:nx1,0:ny1),
     &      vt2(0:nx1,0:ny1), vt3(0:nx1,0:ny1),
     &      svt1(0:ny1), svt2(0:ny1),
     &      svt3(0:ny1), udes(0:ny1), svt4(0:ny1)



       real csxx(0:nx1,0:ny1), csxy(0:nx1,0:ny1), csyy(0:nx1,0:ny1),
     &      cmf(0:nx1,0:ny1), cdiss(0:nx1,0:ny1),csigma(0:nx1,0:ny1),
     &      cwn(0:nx1,0:ny1), ctheta(0:nx1,0:ny1), cubott(0:nx1,0:ny1),
     &      cwh(0:nx1,0:ny1), ceta(0:nx1,0:ny1)


c    cdt = number of timesteps*dt
       real ch(nx1,ny1), cu(nx1,ny1), cv(nx1,ny1),
     &      cdt, cet, cdx, cdy, mtide, cper, cnt, cwh0



        integer nx, ny, nt, it, bc1, nfreqs, jt
        integer wcyc(maxfreq), ncallskip, ang_use, i_hard

       integer cnx0, cny0, mstart, mbcx0, mbcxn, mbcy,
     &     cnw,cnc,cns, cnex



        common/basic/  amp,at,ax,ayy,axx,h,cel,cg,wnk,dd,atold,
     &      aold, ay, axy, cga, cgb, sigkk, nn,
     &      q, dkdt, dldt, kapt, uu, vv, sigma, etat, kk,ll,
     &      omk, etac, part2, part1, ddot12, sigt,
     &      wnkold, kaptold, kkold, llold, ktold, ltold, w,
     &      brflag1, brflag2, brfrac, brt,ccgy, ayc, psi

        common/new/ kbar, lbar, hbar, sigbar,ubar,vbar,kapbar

	common/settings/dx,dy,dt,nx,ny,nt,dx2,dy2,dxsq,dysq,it,
     &                 om, per, bc1, nfreqs, jt

        common/compos/ f1, f2

        common/gen/sfreq, famp, phase, wcyc, sang, wll,cwnl,
     &              tbr,dtdt, ncallskip, ang_use, i_hard

        common/swater/dudx,dudy,dvdx,dvdy,etax,etay,dudt,dvdt,
     &         etaold, etatold, uold, utold, vold, vtold,
     &  dsxxdx, dsxydx, dsxydy, dsyydy, wc, edvis, part1a, part2a,
     &  part3a, part4a, part5a, 
     &  svol, svold, lsw, etsw, etaxx, etayy

        common/more/jm, phi, kaphat, ain2, slope


        common/rk4th/at1, at2, at3, etat1, etat2, etat3,
     &        ut1,ut2,ut3,vt1,vt2,vt3,svt1,svt2,svt3,time,udes,svt4


       common/pass1/ csxx,csxy,csyy,cmf,cdiss,csigma,
     &     cwn,ctheta,cubott,cwh, mtide, cper,cwh0

       common/pass2/ch, cu, cv, cdt, cet, cdx, cdy, cnx0, cny0,
     &   ceta, mstart, mbcx0, mbcxn, mbcy,cnw,cnc,cns, cnt,cnex








