c*************************************
        subroutine SediModule()
         
         include 'pass.h'
         real*8 por, qx(Nx_Max,0:Ny_Max+1), qy(Nx_Max,0:Ny_Max+1),Wo,
     .        c1,c2,c3,qxum(Nx_Max,Ny_Max),qyum(Nx_Max,Ny_Max),
     .        qxslp(Nx_Max,Ny_Max),qyslp(Nx_Max,Ny_Max),
     .        qxsk(Nx_Max,Ny_Max),qysk(Nx_Max,Ny_Max),fw,pie,
     .        uw(0:1000),uw2, uw2sum,uw3,uw3sum,dhodxn(Nx_Max,Ny_Max),
     .        dhodyn(Nx_Max,Ny_Max),fake(Nx_Max,Ny_Max),
     .        fake1(Nx_Max,Ny_Max),fake2(Nx_Max,Ny_Max),
     .        dhdt(Nx_max,Ny_max),ht(Nx_max,Ny_max),dx,dy

	write(*,*)'call SEDIMENT MODULE ......'

c         integer i,j
c         fw=0.008
         c1 = 3
         c2 = 3
c         c3 = .1
         por = 0.35
         Wo=0.022
         pie=4.d0*datan2(1.d0,1.d0)
         dx=X_Sedi(2,1)-X_Sedi(1,1)
         dy=Y_Sedi(1,2)-Y_Sedi(1,1)

c ## Calculate depth gradients

         do i = 1, Nx_Sedi
          do j = 1, Ny_Sedi
             ht(i,j)=Depth_Sedi(i,j)
          end do
         end do

      ncode = 3
      nxflag = 1
      call deriv(ht,fake,fake,dhodxn,dhodyn,fake1,fake2,
     .           ncode,nxflag)


         do i = 1, Nx_Sedi
          do j = 1, Ny_Sedi


           qxum(i,j)=(Intp_Ub_Sedi(i,j)*Intp_Ub_Sedi(i,j)
     .            +Intp_ubott_Sedi(i,j)*Intp_ubott_Sedi(i,j)*.5d0
     .            +Intp_Vb_Sedi(i,j)*Intp_Vb_Sedi(i,j))
     .            *c1/9.8*Intp_fw_Sedi(i,j)*Intp_U_Sedi(i,j)
           qxslp(i,j)=c2*c1*Wo*dhodxn(i,j)/9.8*(Intp_Ub_Sedi(i,j)
     .          *Intp_Ub_Sedi(i,j)+Intp_ubott_Sedi(i,j)
     .          *Intp_ubott_Sedi(i,j)+
     .            Intp_Vb_Sedi(i,j)*Intp_Vb_Sedi(i,j))
c  This is a psuedo skewness with no physical or mathematical justification
           qxsk(i,j)= c1/9.8*Intp_fw_Sedi(i,j)*Intp_ubott_Sedi(i,j)**3d0
     .          *cos(Intp_Theta_Sedi(i,j)*pie/180)
                   
           qx(i,j) = qxum(i,j)
     .          +qxslp(i,j)
     .            +qxsk(i,j)

           qyum(i,j)=(Intp_Ub_Sedi(i,j)*Intp_Ub_Sedi(i,j)
     .            +Intp_ubott_Sedi(i,j)*Intp_ubott_Sedi(i,j)*.5d0
     .            +Intp_Vb_Sedi(i,j)*Intp_Vb_Sedi(i,j))
     .            *c1/9.8*Intp_fw_Sedi(i,j)*Intp_V_Sedi(i,j)
           qyslp(i,j)=c2*c1*Wo*dhodyn(i,j)/9.8*(Intp_Ub_Sedi(i,j)
     .          *Intp_Ub_Sedi(i,j)+Intp_ubott_Sedi(i,j)
     .          *Intp_ubott_Sedi(i,j)+
     .            Intp_Vb_Sedi(i,j)*Intp_Vb_Sedi(i,j))
c  This is a psuedo skewness with no physical or mathematical justification
           qysk(i,j)= c1/9.8*Intp_fw_Sedi(i,j)*Intp_ubott_Sedi(i,j)**3d0
     .          *sin(Intp_Theta_Sedi(i,j)*pie/180)
                   
                  
           qy(i,j) = qyum(i,j)
     .          +qyslp(i,j)
     .            +qysk(i,j)
                   
           end do
         end do


c Bc's - uses same periodic scheme as sc in longshore direction
          do i = 1, Nx_Sedi
            qx(i,0) = qx(i,Ny_Sedi-1)
            qy(i,0) = qy(i,Ny_Sedi-1)
            qx(i,Ny_Sedi+1) = qx(i,2)
            qy(i,Ny_Sedi+1) = qy(i,2)
           end do

c bc's at shoreward wall
        do j = 1, Ny_Sedi
          qx(Nx_Sedi,j) = qx(Nx_Sedi-3,j)
          qx(Nx_Sedi-1,j) = qx(Nx_Sedi-4,j)
          qx(Nx_Sedi-2,j) = qx(Nx_Sedi-5,j)
c          qxum(Nx_Sedi,j) =  qxum(Nx_Sedi-1,j)
c          qxsk(Nx_Sedi,j) = qxsk(Nx_Sedi-1,j)
c          qy(Nx_Sedi+1,j) = qy(Nx_Sedi-1,j)
         end do

c dhdt at interior points
         do i = 2, Nx_Sedi-1
           do j = 1, Ny_Sedi
           dhdt(i,j) =1d0/(1-por)*( qx(i+1,j)-qx(i-1,j))/(2.*dx)
     &                  + (qy(i,j+1) - qy(i,j-1))/(2.*dy)
         end do
        end do 
c  Offshore and shoreline boundary
         do j = 1, Ny_Sedi
           dhdt(1,j) = 0.0
           i=Nx_Sedi
c           dhdt(i,j)=0.0
           dhdt(i,j)=dhdt(i-3,j)
           dhdt(i-1,j)=dhdt(i-4,j)
           dhdt(i-2,j)=dhdt(i-5,j)
         end do
         

c  update depth
         do i = 1, Nx_Sedi
           do j = 1, Ny_Sedi
             ht(i,j)  = ht(i,j) + N_Interval_CallSedi*Master_dt
     &           *dhdt(i,j) !turned on
             Pass_Dupdated(i,j)=ht(i,j)
c             Depth_Wave(i,j)=ht(i,j)
c             Depth_Circ(i,j)=ht(i,j)
c             Depth_Sedi(i,j)=ht(i,j)
           end do
          end do 

          
           open(1,file='qxum.out')
        do i = 1, Nx_Sedi
         write(1,100)(qxum(i,j), j=1,Ny_Sedi )
        end do
        close(1)
           open(1,file='qyum.out')
        do i = 1, Nx_Sedi
         write(1,100)(qyum(i,j), j=1,Ny_Sedi )
        end do
        close(1)
            open(1,file='qxslp.out')
        do i = 1, Nx_Sedi
         write(1,100)(qxslp(i,j), j=1,Ny_Sedi )
        end do
        close(1)
           open(1,file='qyslp.out')
        do i = 1, Nx_Sedi
         write(1,100)(qyslp(i,j), j=1,Ny_Sedi )
        end do
        close(1)
           open(1,file='qxsk.out')
        do i = 1, Nx_Sedi
         write(1,100)(qxsk(i,j), j=1,Ny_Sedi )
        end do
        close(1)
           open(1,file='qysk.out')
        do i = 1, Nx_Sedi
         write(1,100)(qysk(i,j), j=1,Ny_Sedi )
        end do
        close(1)
        
          open(1,file='mqy.out')
        do i = 1, Nx_Sedi
         write(1,100)(qy(i,j), j=1,Ny_Sedi )
        end do
        close(1)


          open(1,file='mqx.out')
        do i = 1, Nx_Sedi
         write(1,100)(qx(i,j), j=1,Ny_Sedi )
        end do
        close(1)
          open(1,file='umb.out')
        do i = 1, Nx_Sedi
         write(1,100)(Intp_Ub_Sedi(i,j), j=1,Ny_Sedi )
        end do
        close(1)
          open(1,file='vmb.out')
        do i = 1, Nx_Sedi
         write(1,100)(Intp_Vb_Sedi(i,j), j=1,Ny_Sedi )
        end do
        close(1)

  100  format(201(f12.8))

         
c         print*, 'Sediment module'
        end


